Package: tRigon
Title: Toolbox for Integrative Pathomics Analysis
Version: 0.3.3
Authors@R: 
  c(person(given = "David",
           family = "Hoelscher", 
           role = c("aut", "cre"),
           email="dhoelscher@ukaachen.de",
           comment = c(ORCID = "0000-0001-8595-0694")),
    person(given = "Roman",
           family = "Buelow", 
           role = c("ctb"),
           comment = c(ORCID = "0000-0002-8527-7353")),
    person(given = "Michael",
           family = "Goedertier", 
           role = c("ctb")))
Maintainer: David Hoelscher <dhoelscher@ukaachen.de>
Description: Processing and analysis of pathomics, omics and other medical datasets.
    'tRigon' serves as a toolbox for descriptive and statistical analysis, correlations, 
    plotting and many other methods for exploratory analysis of high-dimensional datasets.
License: GPL (>= 3)
Imports: boot (>= 1.3-28), caret (>= 6.0-94), data.table (>= 1.14.8),
        dplyr (>= 1.1.2), DT (>= 0.28), factoextra (>= 1.0.7),
        ggcorrplot (>= 0.1.4), ggplot2 (>= 3.4.2), ggpubr (>= 0.6.0),
        ggridges (>= 0.5.4), markdown (>= 1.7), patchwork (>= 1.1.2),
        randomForest (>= 4.7-1.1), RColorBrewer (>= 1.1-3), readxl (>=
        1.4.3), sessioninfo (>= 1.2.2), shiny (>= 1.7.4.1),
        shinydashboardPlus (>= 2.0.3), shinydashboard (>= 0.7.2),
        shinyWidgets (>= 0.7.6), simpleboot (>= 1.1-7), writexl (>=
        1.4.2)
Suggests: knitr, testthat (>= 3.0.0)
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.3.2
VignetteBuilder: knitr
Config/testthat/edition: 3
NeedsCompilation: no
Packaged: 2024-08-24 12:31:53 UTC; dhoel
Author: David Hoelscher [aut, cre] (<https://orcid.org/0000-0001-8595-0694>),
  Roman Buelow [ctb] (<https://orcid.org/0000-0002-8527-7353>),
  Michael Goedertier [ctb]
Repository: CRAN
Date/Publication: 2024-08-24 13:00:02 UTC
Built: R 4.6.0; ; 2026-04-25 14:16:04 UTC; unix

processingData <- fluidRow(
  column(
    width = 4,
    shinydashboard::box(
      title = "Process Data", width = NULL,
      div(style = "margin-top: -10px;"),
      # Input for selecting clinical data
      fileInput("featureData", "Select feature files",
        multiple = TRUE,
        accept = c(".csv"),
        buttonLabel = "Browse"
      ),
      div(style = "margin-top: -15px;"),
      # Input for selecting clinical data
      fileInput("metaData", "Select meta data",
        multiple = FALSE,
        accept = c(".xlsx"),
        buttonLabel = "Browse"
      ),
      div(style = "margin-top: -15px;"),
      # Button for processing
      actionButton("preprocessBtn", "Process", class = "btn-primary", icon = icon("play"), style = "color: primary"),
      div(style = "margin-top: 5px"),
      actionButton("findfeaturesBtn_processeddata", "Find Features", class = "btn-primary", icon = icon("play")),
      div(style = "margin-top: 5px"),
      downloadButton("download_processed", "Save Data"),
      div(style = "margin-top: 5px"),
      downloadButton("report_processeddata", "Save Report")
    )
  ),
  column(
    width = 8,
    shinydashboard::tabBox(
      width = NULL,
      # Output for displaying data and/or metadata summary
      tabPanel("Processed Data",
        fluid = TRUE,
        DT::dataTableOutput("SummaryTable"), style = "height:500px; overflow-y: scroll;overflow-x: scroll;"
      ),
      tabPanel("Meta Data",
        fluid = TRUE,
        DT::dataTableOutput("MetadataTable"), style = "height:500px; overflow-y: scroll;overflow-x: scroll;"
      )
    )
  )
)

# clustering

# perform k-means clustering
clustering <- shiny::reactive({
  df_loaded <- rvals$rval_loadeddf
  df_processed <- rvals$rval_processeddf
  if (rvals$rval_chosendf == "processed") {
    if (!is.null(dim(df_processed))) {
      df_var <- df_processed
    }
  }
  if (rvals$rval_chosendf == "loaded") {
    if (!is.null(dim(df_loaded))) {
      df_var <- df_loaded
    }
  }
  if (input$cluster_groups_en) {
    group_col <- input$groupVar_cluster
    rvals$groups_lvl <- unique(df_var[[group_col]])
  }
  withProgress(
    message = paste0("Computing Clusters"),
    value = 0,
    {
      incProgress(1 / 3)
      if (input$cluster_groups_en) {
        df_cluster <- df_var %>% select(input$groupVar_cluster, input$feature_cluster_variableSelect)
        df_check <- df_cluster %>% select(-input$groupVar_cluster)
      } else {
        df_cluster <- df_var %>% select(input$feature_cluster_variableSelect)
        df_check <- df_cluster
      }
      var_types <- sapply(df_check, is.numeric)
      if (FALSE %in% var_types) {
        showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
        nonnum_var <- names(which(FALSE == var_types))
        validate(
          need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
        )
      }
      rvals$data_warn <- FALSE
      rvals$data_warn_n <- 0
      df_check <- colSums(!is.na(df_check))
      if (length(unique(df_check)) != 1) {
        showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
        rvals$data_warn <- TRUE
        df_check <- df_cluster[rowSums(is.na(df_cluster)) != ncol(df_cluster), ]
        rvals$data_warn_n <- sum(!complete.cases(df_check))
      }
      df_cluster <- df_cluster[complete.cases(df_cluster), ]
      if (input$cluster_groups_en) {
        if (is.numeric(df_cluster[[input$groupVar_cluster]])) {
          showNotification(ui = "Warning: group var is numeric", type = "warning", duration = 5, closeButton = TRUE)
        }
        if (length(unique(df_cluster[[input$groupVar_cluster]])) > input$cluster_n) {
          showNotification(ui = "Please select fewer groups", type = "error", duration = NULL, closeButton = TRUE)
          validate(
            need(length(unique(df_cluster[[input$groupVar_cluster]])) <= input$cluster_n, "Levels of group var cannot be larger than the specified n of clusters.")
          )
        }
      }
      if (input$cluster_groups_en) {
        df_cluster[[group_col]] <- as.character(df_cluster[[group_col]])
        data_cluster <- scale(df_cluster %>% select(input$feature_cluster_variableSelect))
        data_cluster <- cbind(df_cluster[[group_col]], data_cluster)
      } else {
        data_cluster <- scale(df_cluster)
      }
      rvals$rval_data_cluster <- data_cluster
      c <- kmeans(subset(data_cluster, select = input$feature_cluster_variableSelect), centers = input$cluster_n)
    }
  )
  rvals$rval_output_cluster <- c
  c
})

clustering_alg <- shiny::eventReactive(input$clusterBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_cluster_variableSelect)) {
    showNotification(ui = "Please select features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_cluster_variableSelect), "Please select features for k-means Clustering")
    )
  }
  if (input$groupVar_cluster == "" & input$cluster_groups_en == TRUE) {
    showNotification(ui = "Please select a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_cluster != "", "Please select a group variable")
    )
  }
  if (length(input$feature_cluster_variableSelect) < 3) {
    showNotification(ui = "Please select more features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(length(input$feature_cluster_variableSelect) > 1, "Please select at least three features for clustering")
    )
  }
  if (input$cluster_groups_en == TRUE) {
    if (!(input$groupVar_cluster %in% names(rvals$rval_loadeddf) | input$groupVar_cluster %in% names(rvals$rval_processeddf))) {
      showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(input$groupVar_cluster %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
        need(input$groupVar_cluster %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
      )
    }
  }
  if (input$groupVar_cluster %in% input$feature_cluster_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$groupVar_cluster %in% input$feature_cluster_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  }
  clustering()
})

# write output of k-means clustering
output$cluster_output <- shiny::renderPrint({
  clustering_alg()
})

# create plot based on k-means clustering object
output_cluster_p <- shiny::eventReactive(input$clusterBtn, {
  my_palette <- c("#a82203", "#208cc0", "#f1af3a", "#cf5e4e", "#637b31", "#003967", "#60D394", "#37123C", "#172A3A", "#8D5A97", "#01FDF6", "grey")
  withProgress(
    message = paste0("Rendering Plot"),
    value = 0,
    {
      incProgress(1 / 2)
      clustering()
      if (input$cluster_groups_en) {
        cluster_viz <- as.data.frame(rvals$rval_data_cluster[, -c(1)])
        cluster_viz <- cluster_viz %>% dplyr::mutate_all(as.numeric)
        cluster_viz <- cbind(rvals$rval_data_cluster[, c(1)], cluster_viz)
        cluster_viz <- cluster_viz %>% rename_at(1, ~ input$groupVar_cluster)
        cluster_viz[[input$groupVar_cluster]] <- as.character(cluster_viz[[input$groupVar_cluster]])
        cp <- fviz_cluster(clustering_alg(), data = cluster_viz[, -c(1)], geom = "point", palette = my_palette, ggtheme = theme_bw(), shape = 16) + geom_point(aes(shape = cluster_viz[, c(1)])) + scale_shape_manual(values = seq(0, 15), name = input$groupVar_cluster)
        name <- paste("k-means_", input$cluster_n, "_clusters.png", sep = "")
        ggsave(name, cp, path = tempdir())
      } else {
        cluster_viz <- as.data.frame(rvals$rval_data_cluster[, -c(1)])
        cluster_viz <- cluster_viz %>% dplyr::mutate_all(as.numeric)
        cp <- fviz_cluster(clustering_alg(), data = cluster_viz, geom = "point", palette = my_palette, ggtheme = theme_bw(), shape = 16)
        name <- paste("k-means_", input$cluster_n, "_clusters.png", sep = "")
        ggsave(name, cp, path = tempdir())
      }
    }
  )
  rvals$rval_plot_cluster <- cp
  cp
})

# render cluster plot
output$cluster_plot <- renderPlot({
  output_cluster_p()
})

# download cluster plot
output$download_clusterplot <- downloadHandler(
  filename = function() {
    paste("k-means_", input$cluster_n, "_clusters.png", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Plot"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        workingdir <- getwd()
        setwd(tempdir())
        name <- paste("k-means_", input$cluster_n, "_clusters.png", sep = "")
        shiny::incProgress(5 / 10)
        file.copy(name, file, overwrite = TRUE)
        setwd(workingdir)
      }
    )
  }
)

# download report for clustering
output$report_clustering <- downloadHandler(
  filename = "report_clustering.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_cluster.Rmd")
        file.copy("report_cluster.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_vars = input$feature_cluster_variableSelect,
          clusters_n = input$cluster_n,
          groups_en = input$cluster_groups_en,
          group_var = input$groupVar_cluster,
          groups = rvals$groups_lvl,
          warning_data = rvals$data_warn,
          warning_data_n = rvals$data_warn_n,
          cluster_output = rvals$rval_output_cluster,
          cluster_plot = rvals$rval_plot_cluster
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

# descriptive statistics

# calculate summary statistics
ds_data <- reactive({
  withProgress(message = "Calculating", value = 0, {
    var <- c(input$feature_ds_variableSelect, input$groupVar_ds)
    feature <- c(input$feature_ds_variableSelect)
    df_loaded <- rvals$rval_loadeddf
    df_processed <- rvals$rval_processeddf
    if (rvals$rval_chosendf == "processed") {
      if (!is.null(dim(df_processed))) {
        df_var <- df_processed
      }
    }
    if (rvals$rval_chosendf == "loaded") {
      if (!is.null(dim(df_loaded))) {
        df_var <- df_loaded
      }
    }
    if (!is.numeric(df_var[[feature]])) {
      showNotification(ui = "Please select a numeric input as feature", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(is.numeric(df_var[[feature]]), "Please select a numeric input as feature")
      )
    }
    group_col <- input$groupVar_ds
    g <- factor(df_var[[group_col]])
    if (NA %in% g) {
      rvals$na_omit <- TRUE
      df_na <- df_var[which(is.na(df_var[[group_col]])), ]
      df_na <- df_na[which(!is.na(df_na[[feature]])), ]
      rvals$n_na <- count(df_na)
      g <- na.omit(g)
      df_var <- df_var[!is.na(df_var[[group_col]]), ]
    } else {
      rvals$na_omit <- FALSE
      rvals$n_na <- 0
    }
    n_levels <- length(unique(df_var[[group_col]]))
    rvals$groups_lvl <- unique(df_var[[group_col]])
    if (is.numeric(df_var[[input$groupVar_ds]])) {
      showNotification(ui = "Warning: group var is numeric", type = "warning", duration = 5, closeButton = TRUE)
    }
    if (length(unique(df_var[[input$groupVar_ds]])) > 50) {
      showNotification(ui = "Please select fewer groups", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(length(unique(df_var[[input$groupVar_ds]])) <= 50, paste0(length(unique(df_var[[input$groupVar_ds]])), " groups reported. Cannot process more than 50 unique groups."))
      )
    }
    summary_stats <- data.frame()
    i <- 1
    incProgress(i / n_levels)
    for (group_factor in levels(g)) {
      group_df <- df_var[which(df_var[[group_col]] == group_factor), ]
      temp_stats <- summary(group_df[[feature]], na.rm = TRUE)
      temp_stats$var <- var(group_df[[feature]], na.rm = TRUE)
      temp_stats$sd <- sd(group_df[[feature]], na.rm = TRUE)
      temp_stats$iqr <- IQR((group_df[[feature]]), na.rm = TRUE)
      n_datapoints <- group_df %>%
        filter(!is.na(group_df[[feature]])) %>%
        count()
      temp_stats$n_datapoints <- n_datapoints$n
      temp_stats$group_factor <- group_factor
      temp_stats <- as.data.frame(temp_stats) %>% dplyr::select(group_factor, Min., X1st.Qu., Median, Mean, X3rd.Qu., Max., var, sd, iqr, n_datapoints)
      summary_stats <- rbind(summary_stats, temp_stats)
      incProgress(i / n_levels)
      i <- i + 1
    }
    summary_stats$feature <- feature
    summary_stats <- summary_stats %>% dplyr::rename(group = "group_factor", min = "Min.", max = "Max.", median = "Median", mean = "Mean", Q1 = "X1st.Qu.", Q3 = "X3rd.Qu.")
    summary_stats <- summary_stats %>% dplyr::select(group, feature, median, mean, var, sd, min, max, Q1, Q3, iqr, n_datapoints)
    summary_stats[, c(3:11)] <- sapply(summary_stats[, c(3:11)], as.numeric)
    summary_stats <- summary_stats %>% mutate_if(is.numeric, ~ round(., 2))
    summary_stats <- summary_stats %>% rename_at(1, ~ input$groupVar_ds)
    summary_stats
  })
  rvals$rval_dsdf <- summary_stats
})

# write descriptive statistics
output$dsTable <- DT::renderDataTable(ds_df())

ds_df <- eventReactive(input$ds_statisticsBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No preprocessed data loaded"),
      need(!is.null(dim(rvals$rval_processeddf)), "No processed data loaded")
    )
  }
  if (is.null(input$feature_ds_variableSelect)) {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_ds_variableSelect), "Please select a feature for analysis")
    )
  }
  if (input$feature_ds_variableSelect == "... no features found") {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_ds_variableSelect != "... no features found", "Please select a feature for analysis")
    )
  }
  if (input$groupVar_ds == "") {
    showNotification(ui = "Please specify a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_ds != "", "Please specify a group variable")
    )
  }
  if (!(input$groupVar_ds %in% names(rvals$rval_loadeddf) | input$groupVar_ds %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_ds %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$groupVar_ds %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (input$groupVar_ds %in% input$feature_ds_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$groupVar_ds %in% input$feature_ds_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    ds_data()
  }
})

# download descriptive statistics
output$download_ds <- downloadHandler(
  filename = function() {
    paste("feature_statistics_", input$feature_ds_variableSelect, ".xlsx", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Data"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        shiny::incProgress(5 / 10)
        writexl::write_xlsx(rvals$rval_dsdf, file)
      }
    )
  }
)

# download report for descriptive statistics
output$report_ds <- downloadHandler(
  filename = "report_descriptive_stats.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_ds.Rmd")
        file.copy("report_ds.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_var = input$feature_ds_variableSelect,
          group_var = input$groupVar_ds,
          groups = rvals$groups_lvl,
          ds_df = rvals$rval_dsdf,
          na_omit = rvals$na_omit,
          na_n = rvals$n_na
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

descriptiveStats <- fluidRow(
  tags$style(HTML(".selected {background-color: #3EB489 !important;}")),
  column(
    width = 4,
    shinydashboard::box(
      title = "Descriptive Statistics", width = NULL,
      div(style = "margin-top: -10px;"),
      # Input for selecting which variable to analyze
      pickerInput(
        inputId = "feature_ds_variableSelect",
        label = "Select features",
        choices = "... no features found",
        options = list(
          "live-search" = TRUE
        ),
        multiple = FALSE
      ),
      # Grouping variable input
      textInput("groupVar_ds", "Enter grouping variable"),
      # Button for statistics
      actionButton("ds_statisticsBtn", "Calculate", class = "btn-primary", icon = icon("play")),
      div(style = "margin-top: 5px"),
      downloadButton("download_ds", "Save Data"),
      div(style = "margin-top: 5px"),
      downloadButton("report_ds", "Save Report")
    )
  ),
  column(
    width = 8,
    shinydashboard::box(
      title = "Summary", width = NULL,
      # Output for displaying summary statistics
      fluid = TRUE,
      DT::dataTableOutput("dsTable"), style = "height:500px; overflow-y: scroll;overflow-x: scroll;"
    )
  )
)

plots <- fluidRow(
  column(
    width = 4,
    shinydashboard::box(
      title = "Plots", width = NULL,
      div(style = "margin-top: -10px;"),
      # Input for selecting which variable to plot
      pickerInput(
        inputId = "feature_p_variableSelect",
        label = "Select features",
        choices = "... no features found",
        options = list(
          "live-search" = TRUE
        ),
        multiple = FALSE
      ),
      # Grouping variable input
      textInput("groupVar_p", "Enter grouping variable"),
      # specify which plot format
      selectInput(
        inputId = "p_PlotSelect",
        label = "Select graph",
        choices = list("...", Plots = c("Violin plot", "Boxplot", "Violin with Boxplot", "Ridgeline")),
        multiple = FALSE, selectize = FALSE
      ),
      switchInput(inputId = "logscale_switch", "log-scale", labelWidth = "70px"),
      actionButton("plotBtn", "Plot", class = "btn-primary", icon = icon("play")),
      div(style = "margin-top: 5px"),
      downloadButton("download_plot", "Save Plot"),
      div(style = "margin-top: 5px"),
      downloadButton("report_plot", "Save Report")
    )
  ),
  column(
    width = 8,
    shinydashboard::box(
      title = "Feature Plot", width = NULL,
      # Output for displaying plots"
      fluid = TRUE,
      plotOutput("Feature_Plot")
    )
  )
)

# statistical tests

# perform statistical test
stats_data <- reactive({
  withProgress(message = "Calculating", value = 0, {
    suppressWarnings({
      incProgress(1 / 5)
      var <- c(input$feature_stats_variableSelect, input$groupVar_stats)
      feature <- c(input$feature_stats_variableSelect)
      group_col <- input$groupVar_stats
      df_loaded <- rvals$rval_loadeddf
      df_processed <- rvals$rval_processeddf
      if (rvals$rval_chosendf == "processed") {
        if (!is.null(dim(df_processed))) {
          df_var <- df_processed
        }
      }
      if (rvals$rval_chosendf == "loaded") {
        if (!is.null(dim(df_loaded))) {
          df_var <- df_loaded
        }
      }
      if (!is.numeric(df_var[[feature]])) {
        showNotification(ui = "Please select a numeric input as feature", type = "error", duration = NULL, closeButton = TRUE)
        validate(
          need(is.numeric(df_var[[feature]]), "Please select a numeric input as feature")
        )
      }
      if (is.numeric(df_var[[input$groupVar_stats]])) {
        showNotification(ui = "Warning: group var is numeric", type = "warning", duration = 5, closeButton = TRUE)
      }
      if (length(unique(df_var[[input$groupVar_stats]])) >= 50) {
        showNotification(ui = "Please select fewer groups", type = "error", duration = NULL, closeButton = TRUE)
        validate(
          need(length(unique(df_var[[input$groupVar_stats]])) < 50, paste0(length(unique(df_var[[input$groupVar_stats]])), " groups reported. Cannot process more than 50 unique groups."))
        )
      }
      g <- factor(df_var[[group_col]])
      if (NA %in% g) {
        rvals$na_omit <- TRUE
        df_na <- df_var[which(is.na(df_var[[group_col]])), ]
        df_na <- df_na[which(!is.na(df_na[[feature]])), ]
        rvals$n_na <- count(df_na)
        g <- na.omit(g)
        df_var <- df_var[!is.na(df_var[[group_col]]), ]
      } else {
        rvals$na_omit <- FALSE
        rvals$n_na <- 0
      }
      rvals$groups_lvl <- unique(df_var[[group_col]])
      if (input$select_test == "pairwise Wilcoxon-Rank") {
        wilcox <- pairwise.wilcox.test(df_var[[feature]][complete.cases(df_var[[feature]], df_var[[group_col]])], df_var[[group_col]][complete.cases(df_var[[group_col]], df_var[[feature]])], p.adjust.method = "bonferroni", alternative = "two.sided")
        s <- wilcox
        wilcox$data.name <- "df"
        wilcox_df <- as.data.frame(wilcox$p.value)
        s_df <- wilcox_df
        s_df[s_df < 2e-16] <- "<2e-16"
      }
      incProgress(2 / 5)
      if (input$select_test == "bootstrapped CI") {
        compare.levels <- function(i, j) {
          xi <- df_var[[feature]][as.integer(g) == i]
          xj <- df_var[[feature]][as.integer(g) == j]
          sink("NULL")
          temp_booty <- two.boot(xi, xj, median, student = FALSE, 100, na.rm = TRUE)
          t <- boot.ci(temp_booty, type = c("basic"))
          temp_boot <- data.frame(0)
          temp_boot$diff <- median(xi, na.rm = TRUE) - median(xj, na.rm = TRUE)
          temp_boot$lower_CI <- t$basic[4]
          temp_boot$upper_CI <- t$basic[5]
          if (is.null(temp_boot$upper_CI)) {
            temp_boot$upper_CI <- temp_boot$diff
          }
          if (is.null(temp_boot$lower_CI)) {
            temp_boot$lower_CI <- temp_boot$diff
          }
          sink()
          temp_boot <- lapply(temp_boot, round, 2)
          out <- paste(temp_boot$diff, " [", temp_boot$lower_CI, ",", temp_boot$upper_CI, "]", sep = "")
        }
        boot.tbl <- function(compare.levels, level.names, p.adjust.method) {
          ix <- setNames(seq_along(level.names), level.names)
          pp <- outer(
            ix[-1L], ix[-length(ix)],
            function(ivec, jvec) {
              sapply(
                seq_along(ivec),
                function(k) {
                  i <- ivec[k]
                  j <- jvec[k]
                  if (i > j) {
                    compare.levels(i, j)
                  } else {
                    NA_real_
                  }
                }
              )
            }
          )
          il.tri <- lower.tri(pp, TRUE)
          pp
        }
        table_boot <- boot.tbl(compare.levels, levels(g))
        s <- list("difference in feature median with 100-times bootstrapped 95% CI", table_boot)
        s_df <- table_boot
      }
      incProgress(3 / 5)
      if (input$select_test == "Kruskal-Wallis") {
        s <- kruskal.test(df_var[[feature]] ~ df_var[[group_col]])
        s$data.name <- paste("df", input$feature_stats_variableSelect, "~", input$groupVar_stats, sep = " ")
        s_df <- data.frame(0)
        s_df$comparison <- input$groupVar_stats
        s_df$pvalue <- s$p.value
        s_df <- s_df %>% select(comparison, pvalue)
        s_df[s_df < 2e-16] <- "<2e-16"
      }
      incProgress(4 / 5)
      rvals$rval_calc <- s
      rvals$rval_calcdf <- s_df
    })
  })
  s
})

stats_alg <- eventReactive(input$statisticsBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_stats_variableSelect)) {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_stats_variableSelect), "Please select a feature for analysis")
    )
  }
  if (input$feature_stats_variableSelect == "... no features found") {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_stats_variableSelect != "... no features found", "Please select a feature for analysis")
    )
  }
  if (input$groupVar_stats == "") {
    showNotification(ui = "Please specify a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_stats != "", "Please specify a group variable")
    )
  }
  if (!(input$groupVar_stats %in% names(rvals$rval_loadeddf) | input$groupVar_stats %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_stats %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$groupVar_stats %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (input$groupVar_stats %in% input$feature_stats_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$groupVar_stats %in% input$feature_stats_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    stats_data()
  }
})

# render test output to df
stats_algdf <- eventReactive(input$statisticsBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_stats_variableSelect)) {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_stats_variableSelect), "Please select a feature for analysis")
    )
  }
  if (input$feature_stats_variableSelect == "... no features found") {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_stats_variableSelect != "... no features found", "Please select a feature for analysis")
    )
  }
  if (input$groupVar_stats == "") {
    showNotification(ui = "Please specify a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_stats != "", "Please specify a group variable")
    )
  }
  if (!(input$groupVar_stats %in% names(rvals$rval_loadeddf) | input$groupVar_stats %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_stats %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$groupVar_stats %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (input$groupVar_stats %in% input$feature_stats_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$groupVar_stats %in% input$feature_stats_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    stats_data()
    stats_df <- rvals$rval_calcdf
  }
})

# write statistics output
output$stats_output <- renderPrint({
  stats_alg()
})

# write statistics output to df
output$stats_table <- DT::renderDataTable(stats_algdf())

# download stats data
output$download_statsdf <- downloadHandler(
  filename = function() {
    paste("stats_", input$select_test, "_", input$feature_stats_variableSelect, ".xlsx", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Data"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        shiny::incProgress(5 / 10)
        download_statsdf_c <- cbind(" " = rownames(rvals$rval_calcdf), rvals$rval_calcdf)
        writexl::write_xlsx(download_statsdf_c, file)
      }
    )
  }
)

# download report for statistical tests
output$report_stats <- downloadHandler(
  filename = "report_stats.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_stats.Rmd")
        file.copy("report_stats.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_var = input$feature_stats_variableSelect,
          group_var = input$groupVar_stats,
          groups = rvals$groups_lvl,
          test_selection = input$select_test,
          stats_output = rvals$rval_calc,
          stats_df = rvals$rval_calcdf,
          na_omit = rvals$na_omit,
          na_n = rvals$n_na
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

library(dplyr)
library(ggplot2)
library(data.table)
library(DT)
library(readxl)
library(writexl)
library(ggridges)
library(RColorBrewer)
library(simpleboot)
library(boot)
library(factoextra)
library(ggpubr)
library(ggcorrplot)
library(randomForest)
library(caret)
library(patchwork)
library(markdown)

server <- function(input, output, session) {
  options(shiny.maxRequestSize = 10000000000 * 1024^2)
  set.seed(10)

  # reactive values
  rvals <- reactiveValues(
    rval_loadeddf = NULL,
    rval_metadatadf = NULL,
    rval_processeddf = NULL,
    rval_chosendf = NULL,
    rval_nfiles = NULL,
    rval_ID_metadata = NULL,
    rval_ID_feature = NULL,
    rval_IDmatches_df = NULL,
    na_omit = NULL,
    n_na = NULL,
    groups_lvl = NULL,
    rval_dsdf = NULL,
    rval_plot = NULL,
    rval_calc = NULL,
    rval_calcdf = NULL,
    rval_data_cluster = NULL,
    rval_output_cluster = NULL,
    rval_plot_cluster = NULL,
    rval_fi_output = NULL,
    rval_fi_plot = NULL,
    rval_corrdf = NULL,
    rval_corrplot = NULL,
    data_warn_n = NULL,
    data_warn = NULL
  )

  # define color palette
  qual_col_pals <- brewer.pal.info[brewer.pal.info$category == "qual", ]
  col_vector <- unlist(mapply(brewer.pal, qual_col_pals$maxcolors, rownames(qual_col_pals)))
  my_palette <- c("#a82203", "#208cc0", "#f1af3a", "#cf5e4e", "#637b31", "#003967", "#60D394", "#37123C", "#172A3A", "#8D5A97", "#01FDF6", "grey")

  # load dependencies
  source("server-analysis-processData.R", local = TRUE)
  source("server-analysis-loadData.R", local = TRUE)
  source("server-analysis-descriptiveStats.R", local = TRUE)
  source("server-analysis-plots.R", local = TRUE)
  source("server-analysis-testingStats.R", local = TRUE)
  source("server-analysis-clustering.R", local = TRUE)
  source("server-analysis-featureImportance.R", local = TRUE)
  source("server-analysis-correlation.R", local = TRUE)
}

clustering <- fluidRow(
  column(
    width = 4,
    shinydashboard::box(
      title = "k-means Clustering", width = NULL,
      div(style = "margin-top: -10px;"),
      # Input for selecting which variables to analyze
      pickerInput(
        inputId = "feature_cluster_variableSelect",
        label = "Select features", selected = "",
        choices = "...no features found",
        options = list(
          `actions-box` = TRUE,
          size = 12, "live-search" = TRUE
        ),
        multiple = TRUE
      ),
      sliderInput("cluster_n", "Number of clusters",
        min = 2, max = 12,
        value = 6
      ),
      switchInput(inputId = "cluster_groups_en", "show groups", size = "normal", labelWidth = "100px"),
      conditionalPanel(
        condition = "input.cluster_groups_en==1",
        textInput(inputId = "groupVar_cluster", "Enter grouping variable")
      ),
      actionButton("clusterBtn", "Run Algorithm", class = "btn-primary", icon = icon("play")),
      div(style = "margin-top: 5px"),
      downloadButton("download_clusterplot", "Save Plot"),
      div(style = "margin-top: 5px"),
      downloadButton("report_clustering", "Save Report")
    )
  ),
  column(
    width = 8,
    shinydashboard::tabBox(
      width = NULL,
      tabPanel("Summary",
        fluid = TRUE,
        verbatimTextOutput("cluster_output")
      ),
      tabPanel("Plot",
        fluid = TRUE,
        plotOutput("cluster_plot")
      )
    )
  )
)

loadingData <- fluidRow(
  column(
    width = 4,
    shinydashboard::box(
      title = "Load Data", width = NULL,
      div(style = "margin-top: -10px;"),
      # Input for uploading already processed data
      fileInput("preprocData", "Select processed data", multiple = FALSE, accept = c(".csv")),
      div(style = "margin-top: -15px;"),
      # Button for processing
      actionButton("loaddataBtn", "Load", class = "btn-primary", icon = icon("play")),
      actionButton("findfeaturesBtn_loadeddata", "Find Features", class = "btn-primary", icon = icon("play")),
      div(style = "margin-top: 5px"),
      downloadButton("report_loadeddata", "Save Report")
    )
  ),
  column(
    width = 8,
    shinydashboard::box(
      title = "Data", width = NULL,
      # Output for displaying loaded data
      fluid = TRUE,
      DT::dataTableOutput("LoadedDataTable"), style = "height:500px; overflow-y: scroll;overflow-x: scroll;"
    )
  )
)

help_page <- fluidRow(
  column(
    width = 12, title = "Help",
    tabBox(
      width = 12,
      tabPanel("Data",
        div(style = "margin-top: -10px"),
        tags$h4("Loading data"),
        "Choose a dataframe (in .csv format) from your workstation to load into tRigon.",
        "Please always wait until the file selection diplays that the upload was complete and then press the ", em("Load"), " button.",
        "For pathomics data the file should include features as well as clinical or experiment information. You can also load any other non-pathomics dataset into tRigon to perform your exploratory analyses.",
        "You can also load any dataframe which you created during processing and saved with tRigon.",
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report."), br(), br(),
        tags$h4("Processing data"),
        "Select the feature tables (in .csv format) provided by FLASH for the experiment that you want to analyse with tRigon.",
        "Select a metadata or clinical datafile with information about the animal experiments / human samples.",
        "The metadata file needs to be in .xlsx format and has to follow the tRigon guidelines (more below).",
        "If you want to analyse human data, select ", em("Processing human data"), " in the ", em("Settings"), " tab - mouse data is enabled as default.", br(),
        "Mouse data guidelines: please make sure that the metadata file includes an ID (as exactly given in the feature files until the _ separator before the slide position in the filename) and position (the slide position) column. The", em("ID"), "and", em("position"), "columns have to be present and named exactly as written out here.", br(),
        "Human data guidelines: please make sure that the metadata file includes a pseudonym (the sample identifier) and group (clinical data, diseases, etc.) column(s). The", em("pseudonym"), "column has to be included and named in lowercase.", br(),
        "All human pathomics feature files must include the pseudonym in the filename either in the beginning as ", em("pseudonym_"), " or as ", em("_pseudonym_"), " in the middle of the file to be processed. All mouse pathomics feature files must include the ID as the full filename excluding", em("_1_features.csv"),
        "Please always wait for the file upload to be completed before you press the ", em("Process"), " button.",
        "You can download the processed dataframe for future analysis as a .csv-file by clicking the ", em("Save Data"), " button.",
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report."),
        width = "100%"
      ),
      tabPanel("Statistics",
        div(style = "margin-top: -10px"),
        tags$h4("Calculating descriptive statistics"),
        "You can calculate descriptive statistics for all columns as well as provided features.",
        "Simply choose a feature from the dropdown menu and specify the group column.",
        "The group column should represent the labels for all relevant groups that you want to analyse. Each analysed data point has to be provided with its respective label",
        "The group column can be dependent on the mouse experiment, disease or stratified clinical data - please note that the group should be a stratified variable.",
        "tRigon can also stratify numeric variables for you if you want to analyse a numeric input, but please note that numeric inputs are only possible for up to 30 stratified groups.",
        "After selecting a feature and typing in the group column press the ", em("Calculate"), " button.",
        "Descriptive statistics include feature mean, median, variance (var), standard deviation (sd), 1st and 3rd quantile (q1/3), interquartile range (iqr) as well as the n of analysed data points.",
        "You can save the calculated descriptive statistics as an .xslx file by clicking the ", em("Save Data"), " button.",
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report."), br(), br(),
        tags$h4("Performing statistical tests"),
        "tRigon can calculate a variety of statistical tests such as Kruskal-Wallis tests or pairwise Wilcoxon tests.",
        "Due to nature of the pathomics data (large no. of instances, outlier) normality cannot be assumed and only non-parametric tests are performed.",
        "Kruskal-Wallis tests calculate if there is a statistically significant effect between groups based upon the comparison variable.",
        "Pairwise-Wilcoxon tests (with Bonferroni adjustment for multiple testing) and bootstrapped confidence intervalls of difference in feature median between groups can be implemented to analyse feature differences between groups.", br(),
        "The output for each test is displayed in the style of the R console, but can also be viewed as a dataframe.",
        "To download the dataframe of the p-values or feature median difference + CI simply click the ", em("Save Data"), " button.",
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report"), " (please be aware that both tabs need to be rendered before you download a report so that it does not contain empty or old data).",
        width = "100%"
      ),
      tabPanel("Plots",
        div(style = "margin-top: -10px"),
        tags$h4("Drawing plots"),
        "tRigon can create a variety of different plots for all numeric features.",
        "Chose a feature of interest from the dropdown menu and specify the group column.",
        "Then you can select what type of graph you like. Options include violin plots, boxplots, combined violin-box-plots and ridgeline plots.",
        "For displaying distributions it can be helpful to enable a logarithmic scale as the features sometimes include a large variety of measures or outliers.",
        "To enable the log-scale on the y-axis, simply turn the switch to ON. Please note that this is not advised for shape features (as they only range between zero to one) or other well distributed columns.",
        "Please also note that zeros get excluded in logarithmic scales so the sample size might vary slighty.", br(),
        "After specifying all relevant inputs click the ", em("Plot"), " button. You can save the rendered plot as a .png file by clicking ", em("Save Plot."),
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report."),
        width = "100%"
      ),
      tabPanel("Clustering",
        div(style = "margin-top: -10px"),
        tags$h4("Clustering data"),
        "tRigon is also able to perform k-means clustering.",
        "Due to the nature of the feature data with large differences in the number of instances please be careful when comparing different histological structures of features. For k-means clustering only complete cases can be analysed. tRigon will display a warning when the feature input vectors have different lengths.",
        "By turning the slide to ON you can view to which group/subgroup each instance belongs. The group variable can only have as many levels as the max. amount of clusters.", br(),
        "tRigon provides the console output as well as the plot, which can be saved with ", em("Save Plot."),
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report"), " (please be aware that both tabs need to be rendered before you download a report so that it does not contain empty or old data).",
        width = "100%"
      ),
      tabPanel("Feature Importance",
        div(style = "margin-top: -10px"),
        tags$h4("Calculating feature importance"),
        "With tRigon you can also analyse which features are important to determine differences between a dependent variable in your dataset.",
        "Based on the format of the dependent variable you can chose between regression and classification. Regression is best for numeric variables while classification is best for categorical variables (e.g., groups).",
        "You can choose between random forests and recursive feature elimination as common machine learning models for determining feature importance.",
        "For recursive feature elimination you can also specify the number of folds for cross-validation and the number of repeats.", br(),
        "The respective model output is provided in console format, but can be also plotted. The plot output can also be saved.",
        "For regression feature importance is based on increase in mean standard error and increase in node purity while for classification it is based on mean decrease accuracy and gini.",
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report"), " (please be aware that both tabs need to be rendered before you download a report so that it does not contain empty or old data).",
        width = "100%"
      ),
      tabPanel("Correlation",
        div(style = "margin-top: -10px"),
        tags$h4("Correlating features"),
        "tRigon can also be used to test correlations between different features. Please note that only correlations between numeric variables are possible (Pearson).",
        "tRigon can either calculate simple correlations (between two features) or a correlation matrix for at least 3 features. Simply choose the respective tab and select features of interest from the multiple-choice dropdown menu.",
        "To test for feature correlations in specific subgroups (e.g., only a specific disease), turn the slider to ON and specify the subgroup as it is provided in the dataframe.", br(),
        "For simple correlations the output will be provided as a scatter plot including a linear regression line and a dataframe together with analysed datapoints and the calculated Pearson's R as well as p-value.",
        "For multiple correlations the output will be provided as a correlation matrix plot and dataframe.",
        "The correlation matrix plot and data can both be saved by clicking the respective buttons.",
        "You can also download a markdown .html file containing your experiment report with session info, inputs and outputs by clicking on ", em("Save Report"), " (please be aware that both tabs need to be rendered before you download a report so that it does not contain empty or old data).",
        width = "100%"
      )
    )
  )
)

featureImportance <- fluidRow(
  column(
    width = 4,
    shinydashboard::tabBox(
      id = "fi_input", width = NULL,
      tabPanel(
        "Classification",
        div(style = "margin-top: -10px;"),
        # feature importance variables input
        pickerInput(
          inputId = "feature_c_fi_variableSelect",
          label = "Select features",
          choices = "... no features found",
          options = list(
            `actions-box` = TRUE,
            size = 12, "live-search" = TRUE
          ),
          multiple = TRUE
        ),
        # grouping variable input
        textInput("dependentVar_c_fi", "Enter dependent variable"),
        radioButtons("select_c_fimethod", "Select method", list("random forest", "recursive feature elimination")),
        conditionalPanel(
          condition = "input.select_c_fimethod=='recursive feature elimination'",
          sliderInput(
            inputId = "c_n_folds", "number of folds",
            value = 5, step = 1,
            min = 2, max = 10, round = T
          )
        ),
        conditionalPanel(
          condition = "input.select_c_fimethod=='recursive feature elimination'",
          sliderInput(
            inputId = "c_n_repeats", "number of repeats",
            value = 5, step = 1,
            min = 1, max = 10, round = T
          )
        ),
        actionButton("compute_c_FiBtn", "Compute", class = "btn-primary", icon = icon("play")),
        div(style = "margin-top: 5px"),
        downloadButton("download_c_fiplot", "Save Plot"),
        div(style = "margin-top: 5px"),
        downloadButton("report_c_fi", "Save Report")
      ),
      tabPanel(
        "Regression",
        div(style = "margin-top: -10px;"),
        # feature importance variables input
        pickerInput(
          inputId = "feature_r_fi_variableSelect",
          label = "Select features",
          choices = "... no features found",
          options = list(
            `actions-box` = TRUE,
            size = 12, "live-search" = TRUE
          ),
          multiple = TRUE
        ),
        # grouping variable input
        textInput("dependentVar_r_fi", "Enter dependent variable"),
        radioButtons("select_r_fimethod", "Select method", list("random forest", "recursive feature elimination")),
        conditionalPanel(
          condition = "input.select_r_fimethod=='recursive feature elimination'",
          sliderInput(
            inputId = "r_n_folds", "number of folds",
            value = 5, step = 1,
            min = 2, max = 10, round = T
          )
        ),
        conditionalPanel(
          condition = "input.select_r_fimethod=='recursive feature elimination'",
          sliderInput(
            inputId = "r_n_repeats", "number of repeats",
            value = 5, step = 1,
            min = 1, max = 10, round = T
          )
        ),
        actionButton("compute_r_FiBtn", "Compute", class = "btn-primary", icon = icon("play")),
        div(style = "margin-top: 5px"),
        downloadButton("download_r_fiplot", "Save Plot"),
        div(style = "margin-top: 5px"),
        downloadButton("report_r_fi", "Save Report")
      )
    )
  ),
  column(
    width = 8,
    shinydashboard::tabBox(
      width = NULL,
      tabPanel("Importance Summary",
        fluid = TRUE,
        verbatimTextOutput("importance_summary")
      ),
      tabPanel("Importance Plot",
        fluid = TRUE,
        plotOutput("importance_plot")
      )
    )
  )
)

correlation <- fluidRow(
  column(
    width = 4,
    shinydashboard::tabBox(
      id = "corr_input", width = NULL,
      tabPanel(
        "Simple",
        div(style = "margin-top: -10px;"),
        # features input for correlation
        pickerInput(
          inputId = "feature_scorr_variableSelect",
          label = "Select features", selected = "",
          choices = "... no features found",
          options = list(
            `actions-box` = TRUE,
            size = 12, "live-search" = TRUE
          ),
          multiple = TRUE
        ),
        # grouping input
        switchInput(inputId = "input_scorr_subgroups", "subgroups", labelWidth = "100px"),
        conditionalPanel(
          condition = "input.input_scorr_subgroups==1",
          textInput(inputId = "groupVar_scorr", "Enter grouping variable")
        ),
        conditionalPanel(
          condition = "input.input_scorr_subgroups==1",
          textInput(inputId = "groupVar_scorr_name", "Enter subgroup name")
        ),
        actionButton("s_correlationBtn", "Compute", class = "btn-primary", icon = icon("play")),
        div(style = "margin-top: 5px"),
        downloadButton("download_s_corrplot", "Save Plot"),
        div(style = "margin-top: 5px"),
        downloadButton("download_s_corrdf", "Save Data"),
        div(style = "margin-top: 5px"),
        downloadButton("report_s_corr", "Save Report")
      ),
      tabPanel(
        "Multiple",
        div(style = "margin-top: -10px;"),
        # features input for correlation
        pickerInput(
          inputId = "feature_mcorr_variableSelect",
          label = "Select features", selected = "",
          choices = "... no features found",
          options = list(
            `actions-box` = TRUE,
            size = 12, "live-search" = TRUE
          ),
          multiple = TRUE
        ),
        # grouping input
        switchInput(inputId = "input_mcorr_subgroups", "subgroups", labelWidth = "100px"),
        conditionalPanel(
          condition = "input.input_mcorr_subgroups==1",
          textInput(inputId = "groupVar_mcorr", "Enter grouping variable")
        ),
        conditionalPanel(
          condition = "input.input_mcorr_subgroups==1",
          textInput(inputId = "groupVar_mcorr_name", "Enter subgroup name")
        ),
        actionButton("m_correlationBtn", "Compute", class = "btn-primary", icon = icon("play")),
        div(style = "margin-top: 5px"),
        downloadButton("download_m_corrplot", "Save Plot"),
        div(style = "margin-top: 5px"),
        downloadButton("download_m_corrdf", "Save Data"),
        div(style = "margin-top: 5px"),
        downloadButton("report_m_corr", "Save Report")
      )
    )
  ),
  column(
    width = 8,
    shinydashboard::tabBox(
      width = NULL,
      tabPanel("Correlation Plot",
        fluid = TRUE,
        plotOutput(outputId = "corr_plot", width = "100%")
      ),
      tabPanel("Correlation Data",
        fluid = TRUE,
        DT::dataTableOutput("corr_table"), style = "height:500px; overflow-y: scroll;overflow-x: scroll;"
      )
    )
  )
)

settings_page <- fluidRow(
  column(
    width = 12, title = "Settings",
    box(
      width = NULL, title = "Settings",
      div(style = "margin-top: -10px;"),
      tags$h4("Processing Mode (animal / human):"),
      materialSwitch(inputId = "workflowHuman", label = "Human data workflow"),
      "If you want to analyse human data, select the toggle to change the processing mode - animal experiment data is enabled as default.",
      "The processing workflows differ based on the way FLASH processes whole-slide images from animal experiment or human data.",
      "For more information on how to structure the meta data for human or animal experiment data please visit the Help page within tRigon.", br(), br(),
      tags$h4("Keep feature calculations:"),
      materialSwitch(inputId = "keepCalculations", label = "Keep specimen level calculations"),
      "If you want to analyse features on specimen level it is best to do this with feature medians or means - as default they are excluded from the data.",
      "By enabling to keep these specimen-level calculations each feature will come with specimen-level median, mean and standard deviation after processing.",
      "Please note that enabling this will only work during processing and not after pathomics data was already processed."
    )
  )
)

# loading data

# load data to df
loaded_df <- eventReactive(input$loaddataBtn, {
  if (is.null(input$preprocData)) {
    showNotification(ui = "Please select a file to upload", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$preprocData), "Please select a file to upload")
    )
  } else if (FALSE %in% (grepl(".csv", input$preprocData$datapath) | grepl(".xlsx", input$preprocData$datapath))) {
    showNotification(ui = "File format not supported", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(grepl(".csv", input$preprocData$datapath), "Selected file must be either a .csv or .xlsx file")
    )
  } else {
    withProgress(message = "Loading Data", value = 0, {
      req(input$preprocData)
      incProgress(1 / 3)
      if (grepl(".csv", input$preprocData$datapath)) {
        rvals$rval_loadeddf <- fread(input$preprocData$datapath)
      } else {
        rvals$rval_loadeddf <- read_excel(input$preprocData$datapath)
      }
      incProgress(2 / 3)
      names(rvals$rval_loadeddf) <- names(rvals$rval_loadeddf) %>% make.names()
      names(rvals$rval_loadeddf) <- sub("%", "", names(rvals$rval_loadeddf))
      rvals$rval_loadeddf
    })
  }
})

# output loaded table
output$LoadedDataTable <- DT::renderDataTable(loaded_df())

# find features in loaded data
observeEvent(input$findfeaturesBtn_loadeddata, handlerExpr = {
  df_loaded <- rvals$rval_loadeddf
  if (is.null(dim(df_loaded))) {
    showNotification(ui = "Please load data before finding features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(df_loaded)), "Please load a data file before finding features")
    )
  }
  rvals$rval_chosendf <- "loaded"
  withProgress(message = "Finding Features", value = 0, {
    incProgress(3 / 6)
    Sys.sleep(1)
    updatePickerInput(session, "feature_ds_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
    updatePickerInput(session, "feature_p_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
    updatePickerInput(session, "feature_stats_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
    updatePickerInput(session, "feature_cluster_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
    updatePickerInput(session, "feature_c_fi_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
    updatePickerInput(session, "feature_r_fi_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
    updatePickerInput(session, "feature_scorr_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
    updatePickerInput(session, "feature_mcorr_variableSelect",
      choices = sort(names(loaded_df())),
      selected = ""
    )
  })
})

# download report for loaded data
output$report_loadeddata <- downloadHandler(
  filename = "report_data_loaded.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_data_loaded.Rmd")
        file.copy("report_data_loaded.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          datapath_loadeddf = input$preprocData,
          loaded_df = rvals$rval_loadeddf
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

# processing data

# meta data
metadata_df <- eventReactive(input$preprocessBtn, {
  if (is.null(input$metaData)) {
    showNotification(ui = "Please select a metadata file to upload", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$metaData), "Please select a metadata file to upload")
    )
  } else if (!grepl(".xlsx", input$metaData$datapath)) {
    showNotification(ui = "Selected file must be a .xlsx file", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(grepl(".xlsx", input$metaData$datapath), "Selected file must be a .xlsx file")
    )
  } else {
    rvals$rval_metadatadf <- read_excel(input$metaData$datapath, 1)
    read_excel(input$metaData$datapath, 1)
  }
})

# process files to df
process_df <- reactive({
  n_files <- nrow(input$featureData)
  rvals$rval_nfiles <- n_files
  if (input$workflowHuman) { # human workflow based on specimens
    clinical_data <- read_excel(input$metaData$datapath, 1)
    if (!("pseudonym" %in% (colnames(clinical_data)))) {
      showNotification(ui = "Meta data format error", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need("pseudonym" %in% (colnames(clinical_data)), "Meta data file does not contain necessary columns to process human data. Did you mean to process mouse data?")
      )
    }
    withProgress(message = "Processing", value = 0, {
      incProgress(1 / 4)
      my.files <- input$featureData$datapath
      file.names <- gsub("_features.csv", "", input$featureData$name)
      read_df <- function(i) {
        fp <- my.files[[i]]
        dt <- fread(fp)
        dt$filename <- file.names[[i]]
        return(dt)
      }
      incProgress(2 / 4)
      l <- lapply(seq_along(my.files), read_df)
      incProgress(3 / 4)
      combined_data <- rbindlist(l, fill = TRUE)
    })
    withProgress(message = "Merging Data", value = 0, {
      incProgress(2 / 10)
      combined_data <- combined_data[, paste0("file_V", 1:max(sapply(spl <- strsplit(combined_data$filename, "_"), length))) := transpose(spl)][]
      incProgress(3 / 10)
      clinical_data <- read_excel(input$metaData$datapath, 1)
      col_clinical <- colnames(clinical_data)
      incProgress(4 / 10)
      col_clinical <- col_clinical[!col_clinical %in% c("pseudonym")]
      matches <- apply(combined_data[-1], 2, function(col) any(col %in% clinical_data$pseudonym))
      col_match <- colnames(combined_data[-1])[matches]
      incProgress(5 / 10)
      if (input$keepCalculations == FALSE) {
        # drop summary columns if keeping them is disabled
        combined_data <- dplyr::select(combined_data, -contains("MEAN"))
        combined_data <- dplyr::select(combined_data, -contains("MEDIAN"))
        combined_data <- dplyr::select(combined_data, -contains("STD"))
      }
      # replace artificial -1 values with NA
      combined_data[combined_data == -1] <- NA
      incProgress(6 / 10)
      # merge features with clinical information (biopsy type, disease, etc.)
      rvals$rval_metadatadf <- clinical_data
      feature_analysis <- merge(combined_data, clinical_data, by.x = col_match, by.y = "pseudonym")
      incProgress(7 / 10)
      feature_analysis <- feature_analysis %>% rename(patient_ID = col_match)
      feature_analysis <- feature_analysis %>% select(-contains("file_V"), -filename)
      feature_analysis <- Filter(function(x) !all(is.na(x)), feature_analysis)
      feature_analysis <- feature_analysis %>% select(patient_ID, col_clinical, everything())
      rval_ID_metadata <- length(unique(clinical_data$pseudonym))
      rval_ID_feature <- length(unique(combined_data[[col_match]]))
      clinicalID_df <- data.frame(ID = c(unique(clinical_data$pseudonym)))
      featureID_df <- data.frame(ID = c(unique(combined_data[[col_match]])))
      clinicalID_df$match <- clinicalID_df$ID %in% featureID_df$ID
      rvals$rval_IDmatches_df <- full_join(clinicalID_df, featureID_df, by = "ID")
      rvals$rval_IDmatches_df <- rvals$rval_IDmatches_df %>% rename(patient_ID = "ID")
      rvals$rval_IDmatches_df$match[is.na(rvals$rval_IDmatches_df$match)] <- FALSE
      rvals$rval_IDmatches_df <- rvals$rval_IDmatches_df[order(rvals$rval_IDmatches_df$match, decreasing = TRUE), ]
      incProgress(9 / 10)
    })
  } else { # mouse workflow based on slide position and individual tissue pieces
    clinical_data <- read_excel(input$metaData$datapath, 1)
    if (!("ID" %in% (colnames(clinical_data)) && ("position" %in% (colnames(clinical_data))))) {
      showNotification(ui = "Meta data format error", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need("file" %in% (colnames(clinical_data)), "Meta data file does not contain necessary columns to process mouse data. Did you mean to process human data?")
      )
    }
    withProgress(message = "Processing", value = 0, {
      incProgress(1 / 4)
      my.files <- input$featureData$datapath
      file.names <- gsub("_features.csv", "", input$featureData$name)
      read_df <- function(i) {
        fp <- my.files[[i]]
        dt <- fread(fp)
        dt$file <- file.names[[i]]
        return(dt)
      }
      incProgress(2 / 4)
      l <- lapply(seq_along(my.files), read_df)
      incProgress(3 / 4)
      combined_data <- rbindlist(l, fill = TRUE)
    })
    withProgress(message = "Merging Data", value = 0, {
      combined_data <- combined_data[, paste0("file_V", 1:max(sapply(spl <- strsplit(combined_data$file, "_"), length))) := transpose(spl)][]
      n_slidepos <- paste0("file_V", max(sapply(spl <- strsplit(combined_data$file, "_"), length)))
      incProgress(3 / 10)
      clinical_data <- read_excel(input$metaData$datapath, 1)
      rvals$rval_metadatadf <- clinical_data
      col_clinical <- colnames(clinical_data)
      incProgress(4 / 10)
      col_clinical <- col_clinical[!col_clinical %in% c("ID")]
      col_clinical <- col_clinical[!col_clinical %in% c("position")]
      incProgress(5 / 10)
      combined_data <- combined_data %>% rename(slidepos = n_slidepos)
      combined_data <- combined_data %>% dplyr::select(file, slidepos, everything())
      # drop summary columns if keeping them is disabled
      if (input$keepCalculations == FALSE) {
        combined_data <- dplyr::select(combined_data, -contains("MEAN"))
        combined_data <- dplyr::select(combined_data, -contains("MEDIAN"))
        combined_data <- dplyr::select(combined_data, -contains("STD"))
      }
      # replace artificial -1 values with NA
      combined_data[combined_data == -1] <- NA
      incProgress(6 / 10)
      # merge features with clinical information (genotype, experiment, etc.)
      incProgress(7 / 10)
      clinical_data$file <- paste(clinical_data$ID, clinical_data$position, sep = "_")
      clinical_data <- clinical_data %>% dplyr::select(-ID, -position)
      feature_analysis <- merge(combined_data, clinical_data, by = "file")
      feature_analysis <- feature_analysis %>% select(-contains("file_V"))
      feature_analysis <- feature_analysis %>% select(file, col_clinical, everything())
      rval_ID_metadata <- length(unique(clinical_data$file))
      rval_ID_feature <- length(unique(combined_data$file))
      incProgress(8 / 10)
      clinicalID_df <- data.frame(file = c(unique(clinical_data$file)))
      featureID_df <- data.frame(file = c(unique(combined_data$file)))
      clinicalID_df$match <- clinicalID_df$file %in% featureID_df$file
      rvals$rval_IDmatches_df <- full_join(clinicalID_df, featureID_df, by = "file")
      rvals$rval_IDmatches_df$match[is.na(rvals$rval_IDmatches_df$match)] <- FALSE
      rvals$rval_IDmatches_df <- rvals$rval_IDmatches_df[order(rvals$rval_IDmatches_df$match, decreasing = TRUE), ]
      incProgress(9 / 10)
    })
  }
  rvals$rval_processeddf <- feature_analysis
  names(rvals$rval_processeddf) <- names(rvals$rval_processeddf) %>% make.names()
  names(rvals$rval_processeddf) <- sub("%", "", names(rvals$rval_processeddf))
  rvals$rval_processeddf
})

processed_data <- eventReactive(input$preprocessBtn, {
  if (is.null(input$featureData) | is.null(input$metaData)) {
    showNotification(ui = "Please select feature and metadata files to upload", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$featureData), "Please select feature data files to upload"),
      need(!is.null(input$metaData), "Please select a metadata file to upload")
    )
  }
  if (TRUE %in% (!(grepl(".csv", input$featureData$datapath) | grepl(".xlsx", input$metaData$datapath)))) {
    showNotification(ui = "Selected feature files must be .csv files, metadata file must be a .xlsx file", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(grepl(".csv", input$featureData$datapath), "Selected feature files must be .csv files"),
      need(grepl(".xlsx", input$metaData$datapath), "Metadata file must be a .xlsx file")
    )
  } else {
    process_df()
  }
})

# output summary table & metadata
output$SummaryTable <- DT::renderDataTable(processed_data())
output$MetadataTable <- DT::renderDataTable(metadata_df())

# find features in processed data
observeEvent(input$findfeaturesBtn_processeddata, handlerExpr = {
  df_processed <- rvals$rval_processeddf
  if (is.null(dim(df_processed))) {
    showNotification(ui = "Please process data before finding features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(df_processed)), "Please process data before finding features")
    )
  }
  rvals$rval_chosendf <- "processed"
  withProgress(message = "Finding Features", value = 0, {
    incProgress(3 / 6)
    Sys.sleep(1)
    updatePickerInput(session, "feature_ds_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
    updatePickerInput(session, "feature_p_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
    updatePickerInput(session, "feature_stats_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
    updatePickerInput(session, "feature_cluster_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
    updatePickerInput(session, "feature_c_fi_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
    updatePickerInput(session, "feature_r_fi_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
    updatePickerInput(session, "feature_scorr_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
    updatePickerInput(session, "feature_mcorr_variableSelect",
      choices = sort(names(processed_data())),
      selected = ""
    )
  })
})

# download processed dataframe
output$download_processed <- downloadHandler(
  filename = function() {
    paste("processed_featuredata", ".csv", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Data"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        shiny::incProgress(5 / 10)
        fwrite(rvals$rval_processeddf, file)
      }
    )
  }
)

# download report for processed data
output$report_processeddata <- downloadHandler(
  filename = "report_data_processing.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_data_processing.Rmd")
        file.copy("report_data_processing.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = devtools::session_info()$platform,
          human_processing_en = input$workflowHuman,
          calculations_en = input$keepCalculations,
          datapath_metadata = input$metaData,
          datapath_processdata = input$featureData,
          processed_datadf = rvals$rval_processeddf,
          meta_datadf = rvals$rval_metadatadf,
          matchedID_datadf = rvals$rval_IDmatches_df,
          n_files = rvals$rval_nfiles
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

testingStats <- fluidRow(
  column(
    width = 4,
    shinydashboard::box(
      title = "Statistical Tests", width = NULL,
      div(style = "margin-top: -10px;"),
      # Input for selecting which variable to test for
      pickerInput(
        inputId = "feature_stats_variableSelect",
        label = "Select features",
        choices = "... no features found",
        options = list(
          "live-search" = TRUE
        ),
        multiple = FALSE
      ),
      # Grouping variable input
      textInput("groupVar_stats", "Enter comparison variable"),
      radioButtons("select_test", "Select test", list("pairwise Wilcoxon-Rank", "bootstrapped CI", "Kruskal-Wallis")),
      # Button for computation
      actionButton("statisticsBtn", "Compute Test", class = "btn-primary", icon = icon("play")),
      div(style = "margin-top: 5px"),
      downloadButton("download_statsdf", "Save Data"),
      div(style = "margin-top: 5px"),
      downloadButton("report_stats", "Save Report")
    )
  ),
  column(
    width = 8,
    shinydashboard::tabBox(
      width = NULL,
      # Output for displaying data and/or metadata summary
      tabPanel("Output",
        fluid = TRUE,
        verbatimTextOutput("stats_output")
      ),
      tabPanel("Data",
        fluid = TRUE,
        DT::dataTableOutput("stats_table"), style = "height:500px; overflow-y: scroll;overflow-x: scroll;"
      ),
    )
  )
)

library(shiny)
library(shinydashboard)
library(shinydashboardPlus)
library(shinyWidgets)

ui <- shinydashboardPlus::dashboardPage(

  ## header
  header = dashboardHeader(
    tags$li(
      class = "dropdown",
      tags$style(".main-header .navbar {margin-left: 200px; !important}
                  .main-header .logo {width: 200px; !important}")
    ),
    title = tagList(
      span(class = "logo-lg", strong("tRigon v0.3", style = "position: relative; right: 20px")),
      img(class = "logo-mini", src = "tRigon_icon.png", width = "230%", style = "position: relative; bottom: 1px; position: relative; left: 3px")
    )
  ),

  ## sidebar
  sidebar = shinydashboardPlus::dashboardSidebar(
    id = "sidebarmenu", width = 200,
    sidebarMenu(
      menuItem(text = strong("Home", style = "position: relative; left: 3px"), tabName = "home", icon = icon("home")),
      menuItem(
        text = strong("Analysis", style = "position: relative; left: 9px"), tabName = "analysis", startExpanded = FALSE, icon = icon("calculator", style = "position: relative; left: 2px"),
        menuSubItem("Processing", tabName = "processData", icon = icon("angle-right")),
        menuSubItem("Load Data", tabName = "loadData", icon = icon("angle-right")),
        menuSubItem("Feature Summary", tabName = "descriptiveStats", icon = icon("angle-right")),
        menuSubItem("Plots", tabName = "plots", icon = icon("angle-right")),
        menuSubItem("Statistical Tests", tabName = "testingStats", icon = icon("angle-right")),
        menuSubItem("Clustering", tabName = "clustering", icon = icon("angle-right")),
        menuSubItem("Feature Importance", tabName = "featureImportance", icon = icon("angle-right")),
        menuSubItem("Correlation", tabName = "correlation", icon = icon("angle-right"))
      ),
      menuItem(text = strong("Settings", style = "position: relative; left: 5px"), tabName = "settings", icon = icon("cog")),
      menuItem(text = strong("Help", style = "position: relative; left: 10px"), tabName = "help", icon = icon("question", style = "position: relative; left: 2px")),
      menuItem(text = strong("Contact", style = "position: relative; left: 5px"), tabName = "contact", icon = icon("address-book"))
    )
  ),

  ## body
  body = dashboardBody(
    tags$link(rel = "stylesheet", type = "text/css", href = "theme.css"),
    tags$style(HTML("table.dataTable tr.selected td,table.dataTable td.selected {background-color: #3EB489 !important;}")),
    tags$style(HTML("table.dataTable.stripe>tbody>tr.odd.selected>*, table.dataTable.display>tbody>tr.odd.selected>* {box-shadow: none !important}")),
    tags$style(HTML("table.dataTable.stripe>tbody>tr.even.selected>*, table.dataTable.display>tbody>tr.even.selected>* {box-shadow: none !important}")),
    tags$style(HTML("table.dataTable.hover>tbody>tr.selected:hover>*, table.dataTable.display>tbody>tr.selected:hover>* {box-shadow: none !important}")),
    tags$style(HTML(".dataTables_wrapper .dataTables_processing {display: none !important;}")),
    tags$style(HTML(".progress-bar {background-color: #3EB489}")),
    tags$style(HTML(".selected {background-color: #3EB489 !important;}")),
    tags$style(HTML(".dropdown-item.active {background-color: #3EB489 !important;}")),
    tags$style(HTML(".irs--shiny .irs-bar {border-top: 1px solid #3EB489; border-bottom: 1px solid #3EB489; background: #3EB489}")),
    tags$style(HTML(".irs--shiny .irs-from, .irs--shiny .irs-to, .irs--shiny .irs-single {background-color: #3EB489}")),
    tags$style(HTML(".bootstrap-switch .bootstrap-switch-handle-on.bootstrap-switch-primary, .bootstrap-switch .bootstrap-switch-handle-off.bootstrap-switch-primary {background: #3EB489}")),
    tags$style(HTML(".bootstrap-switch .bootstrap-switch-handle-on, .bootstrap-switch .bootstrap-switch-handle-off, .bootstrap-switch .bootstrap-switch-label {padding-right: 6px; padding-left: 6px}")),
    tags$style(HTML(".btn-primary:focus {background-color: #3EB489}")),
    tags$style(HTML(".btn-primary:active {background-color: #3EB489 !important}")),
    tags$style(HTML(".btn-primary:active {border-color: #FFFFF !important}")),
    tags$style(HTML(".btn-primary:focus {border-color: #3EB489}")),
    tags$style(HTML(".btn-primary:hover {border-color: #37a17b}")),
    tags$style(HTML(".label-default.bg-default {background-color: #3EB489 !important}")),
    tags$style(HTML(".sidebar-menu li>a>.fa-angle-left {position: absolute; top: 53%;}")),
    tags$style(HTML(".sidebar-menu .fas.pull-right.fa-angle-down {position: absolute; top: 35% !important; left: 85%}")),
    tags$style(HTML(".sidebar-mini:not(.sidebar-mini-expand-feature).sidebar-collapse .sidebar-menu>li:hover>a>span:not(.pull-right), .sidebar-mini:not(.sidebar-mini-expand-feature).sidebar-collapse .sidebar-menu>li:hover>.treeview-menu {display: block !important;position: absolute;width: 170px;left: 50px;}")),
    tabItems(
      tabItem(tabName = "home", source("ui-home-page.R", local = TRUE)$value),
      tabItem(tabName = "processData", source("ui-analysis-processData.R", local = TRUE)$value),
      tabItem(tabName = "loadData", source("ui-analysis-loadData.R", local = TRUE)$value),
      tabItem(tabName = "descriptiveStats", source("ui-analysis-descriptiveStats.R", local = TRUE)$value),
      tabItem(tabName = "plots", source("ui-analysis-plots.R", local = TRUE)$value),
      tabItem(tabName = "testingStats", source("ui-analysis-testingStats.R", local = TRUE)$value),
      tabItem(tabName = "clustering", source("ui-analysis-clustering.R", local = TRUE)$value),
      tabItem(tabName = "featureImportance", source("ui-analysis-featureImportance.R", local = TRUE)$value),
      tabItem(tabName = "correlation", source("ui-analysis-correlation.R", local = TRUE)$value),
      tabItem(tabName = "settings", source("ui-settings-page.R", local = TRUE)$value),
      tabItem(tabName = "help", source("ui-help-page.R", local = TRUE)$value),
      tabItem(tabName = "contact", source("ui-contact-page.R", local = TRUE)$value)
    )
  ),

  ## footer
  footer = dashboardFooter(
    left = "LaBOORatory of Nephropathology, RWTH Aachen University",
    right = "Copyright (C) 2024, code licensed under GPL-3"
  )
)

# correlation

# perform simple correlation and create result df
scorr_data <- reactive({
  withProgress(
    message = paste0("Rendering Plot"),
    value = 0,
    {
      incProgress(1 / 2)
      df_loaded <- rvals$rval_loadeddf
      df_processed <- rvals$rval_processeddf
      if (rvals$rval_chosendf == "processed") {
        if (!is.null(dim(df_processed))) {
          df_var <- df_processed
        }
      }
      if (rvals$rval_chosendf == "loaded") {
        if (!is.null(dim(df_loaded))) {
          df_var <- df_loaded
        }
      }
      if (input$input_scorr_subgroups) {
        group_name <- input$groupVar_scorr_name
        df_var <- subset(df_var, select = c(input$groupVar_scorr, input$feature_scorr_variableSelect))
        df_check <- df_var %>% select(-input$groupVar_scorr)
        var_types <- sapply(df_check, is.numeric)
        df_corr <- filter(df_var, df_var[, 1] == group_name)
        df_corr <- df_corr %>% dplyr::select(input$feature_scorr_variableSelect)
        if (FALSE %in% var_types) {
          showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
          nonnum_var <- names(which(FALSE == var_types))
          validate(
            need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
          )
        }
        rvals$data_warn <- FALSE
        rvals$data_warn_n <- 0
        df_check <- colSums(!is.na(df_corr))
        if (df_check[1] != df_check[2]) {
          showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
          rvals$data_warn <- TRUE
          df_check <- df_corr[rowSums(is.na(df_corr)) != ncol(df_corr), ]
          rvals$data_warn_n <- sum(!complete.cases(df_corr))
        }
        df_corr <- df_corr[complete.cases(df_corr), ]
        obs_groups <- df_corr %>% count()
        if (any(obs_groups$n < 2)) {
          showNotification(ui = "Too few observations per group", type = "error", duration = NULL, closeButton = TRUE)
          validate(
            need((any(obs_groups$n > 1)), "Too few observations in subgroups to perform correlation analysis.")
          )
        }
        cor_obj <- cor.test(df_corr[[input$feature_scorr_variableSelect[1]]], df_corr[[input$feature_scorr_variableSelect[2]]], na.rm = TRUE)
        df_corr$R <- cor_obj[["estimate"]][["cor"]]
        df_corr$R[duplicated(df_corr$R)] <- NA
        df_corr$p_value <- cor_obj[["p.value"]]
        df_corr$p_value[duplicated(df_corr$p_value)] <- NA
      } else {
        df_corr <- df_var %>% dplyr::select(input$feature_scorr_variableSelect)
        var_types <- sapply(df_corr, is.numeric)
        if (FALSE %in% var_types) {
          showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
          nonnum_var <- names(which(FALSE == var_types))
          validate(
            need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
          )
        }
        rvals$data_warn <- FALSE
        rvals$data_warn_n <- 0
        df_check <- colSums(!is.na(df_corr))
        if (df_check[1] != df_check[2]) {
          showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
          rvals$data_warn <- TRUE
          df_check <- df_corr[rowSums(is.na(df_corr)) != ncol(df_corr), ]
          rvals$data_warn_n <- sum(!complete.cases(df_corr))
        }
        df_corr <- df_corr[complete.cases(df_corr), ]
        obs_groups <- df_corr %>% count()
        if (any(obs_groups$n < 2)) {
          showNotification(ui = "Too few observations per group", type = "error", duration = NULL, closeButton = TRUE)
          validate(
            need((any(obs_groups$n > 1)), "Too few observations in subgroups to perform correlation analysis.")
          )
        }
        cor_obj <- cor.test(df_corr[[input$feature_scorr_variableSelect[1]]], df_corr[[input$feature_scorr_variableSelect[2]]], na.rm = TRUE)
        df_corr$R <- cor_obj[["estimate"]][["cor"]]
        df_corr$R[duplicated(df_corr$R)] <- NA
        df_corr$p_value <- cor_obj[["p.value"]]
        df_corr$p_value[duplicated(df_corr$p_value)] <- NA
      }
      rvals$rval_corrdf <- df_corr
    }
  )
})

# render simple correlation df
scorr_df <- eventReactive(input$s_correlationBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_scorr_variableSelect)) {
    showNotification(ui = "Please select two features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_scorr_variableSelect), "Please select two features for simple correlation analysis")
    )
  }
  if (input$groupVar_scorr == "" & input$input_scorr_subgroups == TRUE) {
    showNotification(ui = "Please select a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_scorr != "", "Please select a group variable")
    )
  }
  if (input$groupVar_scorr_name == "" & input$input_scorr_subgroups == TRUE) {
    showNotification(ui = "Please select a subgroup name", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_scorr_name != "", "Please select a subgroup name")
    )
  }
  if (length(input$feature_scorr_variableSelect) > 2) {
    showNotification(ui = "Please select less features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(length(input$feature_scorr_variableSelect) < 3, "Please select only two features for simple correlation - if you want to analyse more features consider multiple correlation")
    )
  }
  if (input$input_scorr_subgroups == TRUE) {
    if (!(input$groupVar_scorr %in% names(rvals$rval_loadeddf) | input$groupVar_scorr %in% names(rvals$rval_processeddf))) {
      showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(input$groupVar_scorr %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
        need(input$groupVar_scorr %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
      )
    }
    if (!(any(input$groupVar_scorr_name == rvals$rval_loadeddf[[input$groupVar_scorr]])) | any(input$groupVar_scorr_name == rvals$rval_processeddf[[input$groupVar_scorr]])) {
      showNotification(ui = "Subgroup name not found", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(any(input$groupVar_scorr_name == rvals$rval_loadeddf[[input$groupVar_scorr]]), "Subgroup name not found in loaded dataframe"),
        need(any(input$groupVar_scorr_name == rvals$rval_processeddf[[input$groupVar_scorr]]), "Subgroup name not found in processed dataframe")
      )
    }
    if (input$groupVar_scorr %in% input$feature_scorr_variableSelect) {
      showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(!(input$groupVar_scorr %in% input$feature_scorr_variableSelect), "Group variable and feature variable cannot be the same."),
      )
    }
  }
  scorr_data()
})

# create simple correlation plot
scorr_plot <- eventReactive(input$s_correlationBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_scorr_variableSelect)) {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_scorr_variableSelect), "Please select a feature for correlation analysis")
    )
  }
  if (input$groupVar_scorr == "" & input$input_scorr_subgroups == TRUE) {
    showNotification(ui = "Please select a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_scorr != "", "Please select a group variable")
    )
  }
  if (input$groupVar_scorr_name == "" & input$input_scorr_subgroups == TRUE) {
    showNotification(ui = "Please select a subgroup name", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_scorr_name != "", "Please select a subgroup name")
    )
  }
  if (length(input$feature_scorr_variableSelect) < 2) {
    showNotification(ui = "Please select more features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(length(input$feature_scorr_variableSelect) > 1, "Please select more than one feature for correlation")
    )
  } else {
    df_corrplot <- scorr_df()
    feature_x <- colnames(df_corrplot)[1]
    feature_y <- colnames(df_corrplot)[2]
    if (df_corrplot[1, 3] > 0) {
      label_y <- (min(df_corrplot[, 2]) - (max(df_corrplot[, 2]) - min(df_corrplot[, 2])) * 0.1)
    } else {
      label_y <- (max(df_corrplot[, 2]) + (max(df_corrplot[, 2]) - min(df_corrplot[, 2])) * 0.1)
    }
    s_corrp <- ggplot(df_corrplot, aes_string(x = feature_x, y = feature_y)) +
      geom_point(color = "black") +
      geom_smooth(method = lm, se = TRUE) +
      theme_bw() +
      xlab(feature_x) +
      ylab(feature_y) +
      theme(legend.position = "none") +
      ggtitle("") +
      stat_cor(label.x.npc = "left", label.y = label_y, size = 5) +
      theme(axis.text = element_text(size = 9, family = "sans")) +
      theme(axis.title = element_text(size = 11, family = "sans")) +
      theme(plot.title = element_text(size = 12, family = "sans")) +
      theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
      theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
    name <- paste("simplecorrelation_plot.png", sep = "")
    ggsave(name, s_corrp, path = tempdir())
    rvals$rval_corrplot <- s_corrp
    s_corrp
  }
})

# output plot simple or multiple correlation
output$corr_plot <- renderPlot({
  if (input$corr_input == "Simple") {
    scorr_plot()
  } else if (input$corr_input == "Multiple") {
    mcorr_plot()
  }
})

# output df simple or multiple correlation
output$corr_table <- DT::renderDataTable({
  if (input$corr_input == "Simple") {
    scorr_df()
  } else if (input$corr_input == "Multiple") {
    mcorr_df()
  }
})

# download simple correlation data
output$download_s_corrdf <- downloadHandler(
  filename = function() {
    paste("simplecorrelation_data", ".xlsx", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Data"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        shiny::incProgress(5 / 10)
        download_statsdf_corr <- as.data.frame(cbind(" " = rownames(rvals$rval_corrdf), rvals$rval_corrdf))
        writexl::write_xlsx(download_statsdf_corr, file)
      }
    )
  }
)

# download simple correlation plot
output$download_s_corrplot <- downloadHandler(
  filename = function() {
    paste("simplecorrelation_plot.png", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Plot"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        workingdir <- getwd()
        setwd(tempdir())
        name <- paste("simplecorrelation_plot.png", sep = "")
        shiny::incProgress(5 / 10)
        file.copy(name, file, overwrite = TRUE)
        setwd(workingdir)
      }
    )
  }
)

# download simple correlation report
output$report_s_corr <- downloadHandler(
  filename = "report_correlation.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_corr.Rmd")
        file.copy("report_corr.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_vars = input$feature_scorr_variableSelect,
          subgroups_en = input$input_scorr_subgroups,
          corr_method = input$corr_input,
          warning_data = rvals$data_warn,
          warning_data_n = rvals$data_warn_n,
          group_corr = input$groupVar_scorr,
          subgroup_corr = input$groupVar_scorr_name,
          corr_df = rvals$rval_corrdf,
          corr_plot = rvals$rval_corrplot
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

# multiple correlation

# perform simple correlation and create result df
mcorr_data <- reactive({
  withProgress(
    message = paste0("Rendering Plot"),
    value = 0,
    {
      incProgress(1 / 2)
      df_loaded <- rvals$rval_loadeddf
      df_processed <- rvals$rval_processeddf
      if (!is.null(dim(df_processed))) {
        df_var <- df_processed
      }
      if (!is.null(dim(df_loaded))) {
        df_var <- df_loaded
      }
      if (input$input_mcorr_subgroups) {
        group_name <- input$groupVar_mcorr_name
        df_var <- subset(df_var, select = c(input$groupVar_mcorr, input$feature_mcorr_variableSelect))
        df_check <- df_var %>% select(-input$groupVar_mcorr)
        var_types <- sapply(df_check, is.numeric)
        if (FALSE %in% var_types) {
          showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
          nonnum_var <- names(which(FALSE == var_types))
          validate(
            need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
          )
        }
        df_corr <- filter(df_var, df_var[, 1] == group_name)
        df_corr <- df_corr %>% dplyr::select(input$feature_mcorr_variableSelect)
        df_check <- colSums(!is.na(df_corr))
        rvals$data_warn <- FALSE
        rvals$data_warn_n <- 0
        if (length(unique(df_check)) != 1) {
          showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
          rvals$data_warn <- TRUE
          df_check <- df_corr[rowSums(is.na(df_corr)) != ncol(df_corr), ]
          rvals$data_warn_n <- sum(!complete.cases(df_corr))
        }
        obs_groups <- df_corr %>% count()
        if (any(obs_groups$n < 2)) {
          showNotification(ui = "Too few observations per group", type = "error", duration = NULL, closeButton = TRUE)
          validate(
            need(!(any(obs_groups$n > 1)), "Too few observations in subgroups to perform correlation analysis.")
          )
        }
        corr_matrix <- cor(as.matrix(df_corr))
        corr_matrix <- round(corr_matrix$r, 2)
      } else {
        df_corr <- df_var %>% dplyr::select(input$feature_mcorr_variableSelect)
        var_types <- sapply(df_corr, is.numeric)
        if (FALSE %in% var_types) {
          showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
          nonnum_var <- names(which(FALSE == var_types))
          validate(
            need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
          )
        }
        df_check <- colSums(!is.na(df_corr))
        rvals$data_warn <- FALSE
        rvals$data_warn_n <- 0
        if (length(unique(df_check)) != 1) {
          showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
          rvals$data_warn <- TRUE
          df_check <- df_corr[rowSums(is.na(df_corr)) != ncol(df_corr), ]
          rvals$data_warn_n <- sum(!complete.cases(df_corr))
        }
        obs_groups <- df_corr %>% count()
        if (any(obs_groups$n < 2)) {
          showNotification(ui = "Too few observations per group", type = "error", duration = NULL, closeButton = TRUE)
          validate(
            need(!(any(obs_groups$n > 1)), "Too few observations in subgroups to perform correlation analysis.")
          )
        }
        corr_matrix <- cor(as.matrix(df_corr), use = "p", method = "pearson")
        corr_matrix <- round(corr_matrix, 2)
      }
      rvals$rval_corrdf <- corr_matrix
    }
  )
})

# render multiple correlation df
mcorr_df <- eventReactive(input$m_correlationBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_mcorr_variableSelect)) {
    showNotification(ui = "Please select features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_mcorr_variableSelect), "Please select features for correlation analysis")
    )
  }
  if (input$groupVar_mcorr == "" & input$input_mcorr_subgroups == TRUE) {
    showNotification(ui = "Please select a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_mcorr != "", "Please select a group variable")
    )
  }
  if (input$groupVar_mcorr_name == "" & input$input_mcorr_subgroups == TRUE) {
    showNotification(ui = "Please select a subgroup name", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_mcorr_name != "", "Please select a subgroup name")
    )
  }
  if (length(input$feature_mcorr_variableSelect) <= 2) {
    showNotification(ui = "Please select more features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(length(input$feature_mcorr_variableSelect) > 2, "Please select more than two feature for  multiple correlation - for two features consider simple correlation")
    )
  }
  if (input$input_mcorr_subgroups == TRUE) {
    if (!(input$groupVar_mcorr %in% names(rvals$rval_loadeddf) | input$groupVar_mcorr %in% names(rvals$rval_processeddf))) {
      showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(input$groupVar_mcorr %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
        need(input$groupVar_mcorr %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
      )
    }
    if (!(any(input$groupVar_mcorr_name == rvals$rval_loadeddf[[input$groupVar_mcorr]])) | any(input$groupVar_mcorr_name == rvals$rval_processeddf[[input$groupVar_mcorr]])) {
      showNotification(ui = "Subgroup name not found", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(any(input$groupVar_mcorr_name == rvals$rval_loadeddf[[input$groupVar_mcorr]]), "Subgroup name not found in loaded dataframe"),
        need(any(input$groupVar_mcorr_name == rvals$rval_processeddf[[input$groupVar_mcorr]]), "Subgroup name not found in processed dataframe")
      )
    }
    if (input$groupVar_mcorr %in% input$feature_mcorr_variableSelect) {
      showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(!(input$groupVar_mcorr %in% input$feature_mcorr_variableSelect), "Group variable and feature variable cannot be the same."),
      )
    }
  }
  mcorr_data()
})

# create multiple correlation plot
mcorr_plot <- eventReactive(input$m_correlationBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_mcorr_variableSelect)) {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_mcorr_variableSelect), "Please select a feature for correlation analysis")
    )
  }
  if (input$groupVar_mcorr == "" & input$input_mcorr_subgroups == TRUE) {
    showNotification(ui = "Please select a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_mcorr != "", "Please select a group variable")
    )
  }
  if (input$groupVar_mcorr_name == "" & input$input_mcorr_subgroups == TRUE) {
    showNotification(ui = "Please select a subgroup name", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_mcorr_name != "", "Please select a subgroup name")
    )
  }
  if (length(input$feature_mcorr_variableSelect) < 2) {
    showNotification(ui = "Please select more features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(length(input$feature_mcorr_variableSelect) > 1, "Please select more than one feature for correlation")
    )
  } else {
    df_corrplot <- mcorr_df()
    n_features <- length(input$feature_mcorr_variableSelect)
    m_corrp <- ggcorrplot(df_corrplot, method = "square", type = "lower", lab = TRUE, outline.color = "white") +
      theme_bw() + theme(
        axis.title.x = element_blank(),
        axis.title.y = element_blank(),
        panel.grid.major = element_blank(),
        panel.border = element_blank(),
        panel.background = element_blank(),
        axis.ticks = element_blank(),
        axis.text.x = element_text(angle = 45, hjust = 1),
        legend.position = "none"
      )
    name <- paste("correlation_matrix", "_", length(input$feature_mcorr_variableSelect), "features", ".png", sep = "")
    ggsave(name, m_corrp, path = tempdir())
    rvals$rval_corrplot <- m_corrp
    m_corrp
  }
})

# download multiple correlation data
output$download_m_corrdf <- downloadHandler(
  filename = function() {
    paste("multiplecorrelation", "_", length(input$feature_mcorr_variableSelect), "features", ".xlsx", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Data"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        shiny::incProgress(5 / 10)
        download_statsdf_corr <- as.data.frame(cbind(" " = rownames(rvals$rval_corrdf), rvals$rval_corrdf))
        writexl::write_xlsx(download_statsdf_corr, file)
      }
    )
  }
)

# download multiple correlation plot
output$download_m_corrplot <- downloadHandler(
  filename = function() {
    paste("correlation_matrix", "_", length(input$feature_mcorr_variableSelect), "features", ".png", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Plot"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        workingdir <- getwd()
        setwd(tempdir())
        name <- paste("correlation_matrix", "_", length(input$feature_mcorr_variableSelect), "features", ".png", sep = "")
        shiny::incProgress(5 / 10)
        file.copy(name, file, overwrite = TRUE)
        setwd(workingdir)
      }
    )
  }
)

# download multiple correlation report
output$report_m_corr <- downloadHandler(
  filename = "report_correlation.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_corr.Rmd")
        file.copy("report_corr.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_vars = input$feature_mcorr_variableSelect,
          subgroups_en = input$input_mcorr_subgroups,
          corr_method = input$corr_input,
          warning_data = rvals$data_warn,
          warning_data_n = rvals$data_warn_n,
          group_corr = input$groupVar_mcorr,
          subgroup_corr = input$groupVar_mcorr_name,
          corr_df = rvals$rval_corrdf,
          corr_plot = rvals$rval_corrplot
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

# feature importance calculation

# classification fi
df_c_fi <- eventReactive(input$compute_c_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_c_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_c_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_c_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_c_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_c_fi_variableSelect > 3, paste("Please select at least 4 features for ", input$select_c_fimethod, sep = " ")),
    )
  }
  if (input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    calc_c_fi()
  }
})

# classification calculate feature importance object
calc_c_fi <- eventReactive(input$compute_c_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_c_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_c_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_c_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_c_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_c_fi_variableSelect > 3, paste("Please select at least 4 features for ", input$select_c_fimethod, sep = "")),
    )
  }
  if (input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    df_loaded <- rvals$rval_loadeddf
    df_processed <- rvals$rval_processeddf
    if (rvals$rval_chosendf == "processed") {
      if (!is.null(dim(df_processed))) {
        df_var <- df_processed
      }
    }
    if (rvals$rval_chosendf == "loaded") {
      if (!is.null(dim(df_loaded))) {
        df_var <- df_loaded
      }
    }
    group_col <- input$dependentVar_c_fi
    features <- input$feature_c_fi_variableSelect
    g <- factor(df_var[[group_col]])
    if (NA %in% g) {
      rvals$na_omit <- TRUE
      df_na <- df_var[which(is.na(df_var[[group_col]])), ]
      df_na <- as.data.frame(subset(df_na, select = c(features)))
      rvals$n_na <- count(df_na[complete.cases(df_na), ])
      g <- na.omit(g)
      df_var <- df_var[!is.na(df_var[[group_col]]), ]
    } else {
      rvals$na_omit <- FALSE
      rvals$n_na <- 0
    }
    rvals$groups_lvl <- as.character(unique(df_var[[group_col]]))
    if (is.numeric(df_var[[input$dependentVar_c_fi]])) {
      showNotification(ui = "Numeric dependent var - consider regression", type = "warning", duration = 5, closeButton = TRUE)
    }
    if (length(unique(df_var[[input$dependentVar_c_fi]])) >= 20) {
      showNotification(ui = "Please select fewer groups or consider doing regression instead of classification", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(length(unique(df_var[[input$dependentVar_c_fi]])) < 20, paste0(length(unique(df_var[[input$dependentVar_c_fi]])), " groups reported. Cannot process more than 20 unique groups for classification. Did you mean to do regression?"))
      )
    }
    df_var[[group_col]] <- as.character(df_var[[group_col]])
    if (input$select_c_fimethod == "random forest") {
      withProgress(
        message = paste0("Growing Trees"),
        value = 0,
        {
          incProgress(1 / 5)
          df_rf <- as.data.frame(subset(df_var, select = c(input$dependentVar_c_fi, features)))
          df_check <- df_rf %>% select(-input$dependentVar_c_fi)
          var_types <- sapply(df_check, is.numeric)
          if (FALSE %in% var_types) {
            showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
            nonnum_var <- names(which(FALSE == var_types))
            validate(
              need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
            )
          }
          rvals$data_warn <- FALSE
          rvals$data_warn_n <- 0
          df_check <- colSums(!is.na(df_check))
          if (length(unique(df_check)) != 1) {
            showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
            rvals$data_warn <- TRUE
            df_check <- df_rf[rowSums(is.na(df_rf)) != ncol(df_rf), ]
            rvals$data_warn_n <- sum(!complete.cases(df_check))
          }
          incProgress(2 / 5)
          df_rf <- df_rf[complete.cases(df_rf), ]
          obs_groups <- df_rf %>%
            group_by_at(input$dependentVar_c_fi) %>%
            count()
          if (any(obs_groups$n == 1)) {
            showNotification(ui = "Warning: only one observation in group", type = "warning", duration = 3, closeButton = TRUE)
          }
          df_rf <- df_rf %>% mutate_if(is.numeric, scale)
          incProgress(3 / 5)
          df_rf <- df_rf %>% mutate(dependentVar_c_fiRF = factor(df_rf[[input$dependentVar_c_fi]]))
          incProgress(4 / 5)
          df_rf <- df_rf[, -1]
          fi <- randomForest(dependentVar_c_fiRF ~ ., data = df_rf, importance = TRUE, na.action = na.exclude)
        }
      )
    } else if (input$select_c_fimethod == "recursive feature elimination") {
      rfe_c_cont <- rfeControl(
        functions = rfFuncs,
        method = "repeatedcv",
        number = input$c_n_folds,
        repeats = input$c_n_repeats
      )
      n_c_fi <- length(input$feature_c_fi_variableSelect)
      withProgress(
        message = paste0("Computing RFE"),
        value = 0,
        {
          incProgress(1 / 3)
          fi <- caret::rfe(x = x_train_c_rfe(), y = y_train_c_rfe(), size = n_c_fi, rfeControl = rfe_c_cont)
        }
      )
    }
    fi
  }
})

# classification create feature importance plot object
output_c_fi_plot <- eventReactive(input$compute_c_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_c_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_c_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_c_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_c_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_c_fi_variableSelect > 3, paste("Please select at least 4 features for", input$select_c_fimethod, sep = "")),
    )
  }
  if (input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    obj_fi <- df_c_fi()
    if (input$select_c_fimethod == "random forest") {
      withProgress(
        message = paste0("Rendering Plot"),
        value = 0,
        {
          incProgress(1 / 2)
          V <- as.data.frame(obj_fi$importance)
          rf_plot_accuracy <- ggplot2::ggplot(V, aes(y = reorder(rownames(V), MeanDecreaseAccuracy), x = MeanDecreaseAccuracy)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = rownames(V), yend = rownames(V), x = 0, xend = MeanDecreaseAccuracy), color = "black") +
            ylab("features") +
            xlab("Mean Decrease Accuracy") +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_accuracy <- rf_plot_accuracy + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plot_GINI <- ggplot2::ggplot(V, aes(y = reorder(rownames(V), MeanDecreaseGini), x = MeanDecreaseGini)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = rownames(V), yend = rownames(V), x = 0, xend = MeanDecreaseGini), color = "black") +
            ylab("features") +
            xlab("Mean Decrease Gini") +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_GINI <- rf_plot_GINI + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plots <- (rf_plot_accuracy + rf_plot_GINI)
          name <- paste("RandomForest_Classification_FeatureImportancePlot", ".png", sep = "")
          ggsave(name, rf_plots, path = tempdir())
        }
      )
    } else if (input$select_c_fimethod == "recursive feature elimination") {
      withProgress(
        message = paste0("Rendering Plot"),
        value = 0,
        {
          incProgress(1 / 2)
          varimp_data <- data.frame(
            feature = row.names(varImp(obj_fi))[1:length(predictors(obj_fi))],
            obj_fi[["fit"]][["importance"]]
          )
          rf_plot_accuracy <- ggplot(data = varimp_data, aes(y = reorder(rownames(varimp_data), MeanDecreaseAccuracy), x = MeanDecreaseAccuracy)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = feature, yend = feature, x = 0, xend = MeanDecreaseAccuracy), color = "black") +
            labs(y = "features", x = "Mean Decrease Accuracy") +
            geom_text(aes(label = round(MeanDecreaseAccuracy, 2)), vjust = 1.6, color = "white", size = 4) +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_accuracy <- rf_plot_accuracy + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plot_GINI <- ggplot(data = varimp_data, aes(y = reorder(rownames(varimp_data), MeanDecreaseGini), x = MeanDecreaseGini)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = feature, yend = feature, x = 0, xend = MeanDecreaseGini), color = "black") +
            labs(y = "features", x = "Mean Decrease Gini") +
            geom_text(aes(label = round(MeanDecreaseGini, 2)), vjust = 1.6, color = "white", size = 4) +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_GINI <- rf_plot_GINI + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plots <- (rf_plot_accuracy + rf_plot_GINI)
          name <- paste("RFE_Classification_FeatureImportancePlot", ".png", sep = "")
          ggsave(name, rf_plots, path = tempdir())
        }
      )
    }
    rvals$rval_fi_plot <- rf_plots
    rf_plots
  }
})

# output importance plot regression or classification
output$importance_plot <- renderPlot({
  if (input$fi_input == "Classification") {
    output_c_fi_plot()
  } else if (input$fi_input == "Regression") {
    output_r_fi_plot()
  }
})

# output summary regression or classification
output$importance_summary <- renderPrint({
  if (input$fi_input == "Classification") {
    output_c_fi()
  } else if (input$fi_input == "Regression") {
    output_r_fi()
  }
})

# write classification feature importance output
output_c_fi <- eventReactive(input$compute_c_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_c_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_c_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_c_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_c_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_c_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_c_fi_variableSelect > 3, paste("Please select at least 4 features for", input$select_c_fimethod, sep = "")),
    )
  }
  if (input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_c_fi %in% input$feature_c_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    if (input$select_c_fimethod == "random forest") {
      a <- df_c_fi()
      b <- importance(a)
      out_fi <- list(a, b)
    } else if (input$select_c_fimethod == "recursive feature elimination") {
      a <- df_c_fi()
      b <- a[["fit"]][["importance"]]
      c <- rfe_c_test()
      out_fi <- list(a, b, c)
    }
    rvals$rval_fi_output <- out_fi
    out_fi
  }
})

# classification rfe
rfe_c_data <- reactive({
  df_loaded <- rvals$rval_loadeddf
  df_processed <- rvals$rval_processeddf
  if (rvals$rval_chosendf == "processed") {
    if (!is.null(dim(df_processed))) {
      df_var <- df_processed
    }
  }
  if (rvals$rval_chosendf == "loaded") {
    if (!is.null(dim(df_loaded))) {
      df_var <- df_loaded
    }
  }
  features <- input$feature_c_fi_variableSelect
  df_rfe <- as.data.frame(subset(df_var, select = c(input$dependentVar_c_fi, features)))
  df_check <- df_rfe %>% select(-input$dependentVar_c_fi)
  var_types <- sapply(df_check, is.numeric)
  if (FALSE %in% var_types) {
    showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
    nonnum_var <- names(which(FALSE == var_types))
    validate(
      need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
    )
  }
  rvals$data_warn <- FALSE
  rvals$data_warn_n <- 0
  df_check <- colSums(!is.na(df_check))
  if (length(unique(df_check)) != 1) {
    showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
    rvals$data_warn <- TRUE
    df_check <- df_rfe[rowSums(is.na(df_rfe)) != ncol(df_rfe), ]
    rvals$data_warn_n <- sum(!complete.cases(df_check))
  }
  obs_groups <- df_rfe %>%
    group_by_at(input$dependentVar_c_fi) %>%
    count()
  if (any(obs_groups$n == 1)) {
    showNotification(ui = "Too few observations per group", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(any(obs_groups$n == 1)), "Too few observations in subgroups to perform splitting for training/testing. Please choose another dependent variable or perform random forest instead.")
    )
  }
  df_rfe <- df_rfe[complete.cases(df_rfe), ]
  df_rfe_var <- df_rfe %>% select(-input$dependentVar_c_fi)
  df_rfe_var <- df_rfe_var %>% mutate_if(is.numeric, scale)
  df_rfe <- df_rfe %>% mutate(group = factor(df_rfe[[input$dependentVar_c_fi]]))
  df_rfe <- cbind(df_rfe_var, df_rfe$group)
  df_rfe <- df_rfe %>% rename(group = "df_rfe$group")
  df_rfe
})

# classifcation RFE data splits
y_c <- reactive({
  y_c <- rfe_c_data()
  y_c$group
})

x_c <- reactive({
  x_c_rfe <- rfe_c_data()
  x_c <- x_c_rfe[, names(x_c_rfe) != "group"]
  x_c
})

dataTrain_c_rfe <- reactive({
  caret::createDataPartition(y_c(), p = .80, list = FALSE)[, 1]
})

x_train_c_rfe <- reactive({
  x_c()[dataTrain_c_rfe(), ]
})

x_test_c_rfe <- reactive({
  x_c()[-dataTrain_c_rfe(), ]
})

y_train_c_rfe <- reactive({
  y_c()[dataTrain_c_rfe()]
})

y_test_c_rfe <- reactive({
  y_c()[-dataTrain_c_rfe()]
})

rfe_c_test <- reactive({
  postResample(predict(df_c_fi(), x_test_c_rfe()), y_test_c_rfe())
})

# download classification feature importance plot
output$download_c_fiplot <- downloadHandler(
  filename = function() {
    if (input$select_c_fimethod == "random forest") {
      paste("RandomForest_Classification_FeatureImportancePlot", ".png", sep = "")
    } else if (input$select_c_fimethod == "recursive feature elimination") {
      paste("RFE_Classification_FeatureImportancePlot", ".png", sep = "")
    }
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Plot"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        workingdir <- getwd()
        setwd(tempdir())
        if (input$select_c_fimethod == "random forest") {
          name <- paste("RandomForest_Classification_FeatureImportancePlot", ".png", sep = "")
        } else if (input$select_c_fimethod == "recursive feature elimination") {
          name <- paste("RFE_Classification_FeatureImportancePlot", ".png", sep = "")
        }
        shiny::incProgress(5 / 10)
        file.copy(name, file, overwrite = TRUE)
        setwd(workingdir)
      }
    )
  }
)

# download report for classification feature importance
output$report_c_fi <- downloadHandler(
  filename = "report_featureimportance.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_fi.Rmd")
        file.copy("report_fi.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_vars = input$feature_c_fi_variableSelect,
          dependent_var = input$dependentVar_c_fi,
          groups = rvals$groups_lvl,
          warning_data = rvals$data_warn,
          warning_data_n = rvals$data_warn_n,
          fi_method = input$fi_input,
          fi_model = input$select_c_fimethod,
          folds_n = input$c_n_folds,
          repeats_n = input$c_n_repeats,
          fi_output = rvals$rval_fi_output,
          fi_plot = rvals$rval_fi_plot,
          na_omit = rvals$na_omit,
          na_n = rvals$n_na
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

# regression fi
df_r_fi <- eventReactive(input$compute_r_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_r_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_r_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_r_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_r_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_r_fi_variableSelect > 3, paste("Please select at least 4 features for ", input$select_r_fimethod, sep = " ")),
    )
  }
  if (input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    calc_r_fi()
  }
})

# regression calculate feature importance object
calc_r_fi <- eventReactive(input$compute_r_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_r_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_r_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_r_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_r_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_r_fi_variableSelect > 3, paste("Please select at least 4 features for ", input$select_r_fimethod, sep = "")),
    )
  }
  if (input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    df_loaded <- rvals$rval_loadeddf
    df_processed <- rvals$rval_processeddf
    if (rvals$rval_chosendf == "processed") {
      if (!is.null(dim(df_processed))) {
        df_var <- df_processed
      }
    }
    if (rvals$rval_chosendf == "loaded") {
      if (!is.null(dim(df_loaded))) {
        df_var <- df_loaded
      }
    }
    group_col <- input$dependentVar_r_fi
    features <- input$feature_r_fi_variableSelect
    g <- df_var[[group_col]]
    if (NA %in% g) {
      rvals$na_omit <- TRUE
      df_na <- df_var[which(is.na(df_var[[group_col]])), ]
      df_na <- as.data.frame(subset(df_na, select = c(features)))
      rvals$n_na <- count(df_na[complete.cases(df_na), ])
      g <- na.omit(g)
      df_var <- df_var[!is.na(df_var[[group_col]]), ]
    } else {
      rvals$na_omit <- FALSE
      rvals$n_na <- 0
    }
    rvals$groups_lvl <- unique(df_var[[group_col]])
    if (!(is.numeric(df_var[[input$dependentVar_r_fi]]))) {
      showNotification(ui = "Non-numeric dependent variable", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(is.numeric(df_var[[input$dependentVar_r_fi]]), "Dependant variable is non-numeric. Did you mean to do classification?")
      )
    }
    if (input$select_r_fimethod == "random forest") {
      withProgress(
        message = paste0("Growing Trees"),
        value = 0,
        {
          incProgress(1 / 5)
          features <- input$feature_r_fi_variableSelect
          df_rf <- as.data.frame(subset(df_var, select = c(input$dependentVar_r_fi, features)))
          df_check <- df_rf %>% select(-input$dependentVar_r_fi)
          var_types <- sapply(df_check, is.numeric)
          if (FALSE %in% var_types) {
            showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
            nonnum_var <- names(which(FALSE == var_types))
            validate(
              need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
            )
          }
          rvals$data_warn <- FALSE
          rvals$data_warn_n <- 0
          df_check <- colSums(!is.na(df_check))
          if (length(unique(df_check)) != 1) {
            showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
            rvals$data_warn <- TRUE
            df_check <- df_rf[rowSums(is.na(df_rf)) != ncol(df_rf), ]
            rvals$data_warn_n <- sum(!complete.cases(df_check))
          }
          incProgress(2 / 5)
          df_rf <- df_rf[complete.cases(df_rf), ]
          df_scale <- df_rf %>% select(-input$dependentVar_r_fi)
          df_scale <- df_scale %>% mutate_if(is.numeric, scale)
          df_rf <- cbind(df_rf[[input$dependentVar_r_fi]], df_scale)
          incProgress(3 / 5)
          colnames(df_rf)[1] <- input$dependentVar_r_fi
          incProgress(4 / 5)
          y <- df_rf[, 1]
          df_rf <- df_rf %>% select(-input$dependentVar_r_fi)
          fi <- randomForest(y ~ ., data = df_rf, importance = TRUE, na.action = na.exclude)
        }
      )
    } else if (input$select_r_fimethod == "recursive feature elimination") {
      rfe_r_cont <- rfeControl(
        functions = rfFuncs,
        method = "repeatedcv",
        number = input$r_n_folds,
        repeats = input$r_n_repeats
      )
      n_r_fi <- length(input$feature_r_fi_variableSelect)
      withProgress(
        message = paste0("Computing RFE"),
        value = 0,
        {
          incProgress(1 / 3)
          fi <- caret::rfe(x = x_train_r_rfe(), y = y_train_r_rfe(), size = n_r_fi, rfeControl = rfe_r_cont)
        }
      )
    }
    fi
  }
})

# regression create feature importance plot object
output_r_fi_plot <- eventReactive(input$compute_r_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_r_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_r_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_r_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_r_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_r_fi_variableSelect > 3, paste("Please select at least 4 features for", input$select_r_fimethod, sep = "")),
    )
  }
  if (input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    obj_fi <- df_r_fi()
    if (input$select_r_fimethod == "random forest") {
      withProgress(
        message = paste0("Rendering Plot"),
        value = 0,
        {
          incProgress(1 / 2)
          V <- as.data.frame(obj_fi$importance)
          V <- V %>% rename(IncMSE = "%IncMSE")
          rf_plot_MSE <- ggplot2::ggplot(V, aes(y = reorder(rownames(V), IncMSE), x = IncMSE)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = rownames(V), yend = rownames(V), x = 0, xend = IncMSE), color = "black") +
            ylab("feature") +
            xlab("Mean Square Error (%inc)") +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_MSE <- rf_plot_MSE + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plot_NodePurity <- ggplot2::ggplot(V, aes(y = reorder(rownames(V), IncNodePurity), x = IncNodePurity)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = rownames(V), yend = rownames(V), x = 0, xend = IncNodePurity), color = "black") +
            ylab("feature") +
            xlab("Increase Node Purity") +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_NodePurity <- rf_plot_NodePurity + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plots <- (rf_plot_MSE + rf_plot_NodePurity)
          name <- paste("RandomForest_Regression_FeatureImportancePlot", ".png", sep = "")
          ggsave(name, rf_plots, path = tempdir())
        }
      )
    } else if (input$select_r_fimethod == "recursive feature elimination") {
      withProgress(
        message = paste0("Rendering Plot"),
        value = 0,
        {
          incProgress(1 / 2)
          varimp_data <- data.frame(
            feature = row.names(varImp(obj_fi))[1:length(predictors(obj_fi))],
            obj_fi[["fit"]][["importance"]]
          )
          varimp_data <- varimp_data %>% rename(IncMSE = "X.IncMSE")
          rf_plot_MSE <- ggplot(data = varimp_data, aes(y = reorder(rownames(varimp_data), IncMSE), x = IncMSE)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = feature, yend = feature, x = 0, xend = IncMSE), color = "black") +
            labs(y = "features", x = "Mean Square Error (%inc)") +
            geom_text(aes(label = round(IncMSE, 2)), vjust = 1.6, color = "white", size = 4) +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_MSE <- rf_plot_MSE + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plot_NodePurity <- ggplot(data = varimp_data, aes(y = reorder(rownames(varimp_data), IncNodePurity), x = IncNodePurity)) +
            geom_point(color = "black", size = 4, alpha = 1) +
            geom_segment(aes(y = feature, yend = feature, x = 0, xend = IncNodePurity), color = "black") +
            labs(y = "features", x = "Increase Node Purity") +
            geom_text(aes(label = round(IncNodePurity, 2)), vjust = 1.6, color = "white", size = 4) +
            theme_bw() +
            theme(legend.position = "none") +
            theme(axis.text = element_text(size = 7, family = "sans")) +
            theme(axis.title = element_text(size = 10, family = "sans")) +
            theme(plot.title = element_text(size = 12, family = "sans")) +
            theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
            theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
          rf_plot_NodePurity <- rf_plot_NodePurity + geom_vline(aes(xintercept = 0), linetype = "dashed", colour = "grey")
          rf_plots <- (rf_plot_MSE + rf_plot_NodePurity)
          name <- paste("RFE_Regression_FeatureImportancePlot", ".png", sep = "")
          ggsave(name, rf_plots, path = tempdir())
        }
      )
    }
    rvals$rval_fi_plot <- rf_plots
    rf_plots
  }
})

# write regression feature importance output
output_r_fi <- eventReactive(input$compute_r_FiBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (input$dependentVar_r_fi == "") {
    showNotification(ui = "Please specify a dependent variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi != "", "Please specify a dependent variable")
    )
  }
  if (!(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf) | input$dependentVar_r_fi %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$dependentVar_r_fi %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$dependentVar_r_fi %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (length(input$feature_r_fi_variableSelect) < 4) {
    showNotification(ui = "Please select min. 4 features", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_r_fi_variableSelect > 3, paste("Please select at least 4 features for", input$select_r_fimethod, sep = "")),
    )
  }
  if (input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$dependentVar_r_fi %in% input$feature_r_fi_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    if (input$select_r_fimethod == "random forest") {
      a <- df_r_fi()
      b <- importance(a)
      out_fi <- list(a, b)
    } else if (input$select_r_fimethod == "recursive feature elimination") {
      a <- df_r_fi()
      b <- a[["fit"]][["importance"]]
      c <- rfe_r_test()
      out_fi <- list(a, b, c)
    }
    rvals$rval_fi_output <- out_fi
    out_fi
  }
})

# regression rfe
rfe_r_data <- reactive({
  df_loaded <- rvals$rval_loadeddf
  df_processed <- rvals$rval_processeddf
  if (rvals$rval_chosendf == "processed") {
    if (!is.null(dim(df_processed))) {
      df_var <- df_processed
    }
  }
  if (rvals$rval_chosendf == "loaded") {
    if (!is.null(dim(df_loaded))) {
      df_var <- df_loaded
    }
  }
  features <- input$feature_r_fi_variableSelect
  df_rfe <- as.data.frame(subset(df_var, select = c(input$dependentVar_r_fi, features)))
  df_check <- df_rfe %>% select(-input$dependentVar_r_fi)
  var_types <- sapply(df_check, is.numeric)
  if (FALSE %in% var_types) {
    showNotification(ui = "Please select only numeric inputs", type = "error", duration = NULL, closeButton = TRUE)
    nonnum_var <- names(which(FALSE == var_types))
    validate(
      need(!(FALSE %in% var_types), paste0("non-numeric feature selected: ", nonnum_var, sep = ""))
    )
  }
  rvals$data_warn <- FALSE
  rvals$data_warn_n <- 0
  df_check <- colSums(!is.na(df_check))
  if (length(unique(df_check)) != 1) {
    showNotification(ui = "Unequal vector length - data loss", type = "warning", duration = 3, closeButton = TRUE)
    rvals$data_warn <- TRUE
    df_check <- df_rfe[rowSums(is.na(df_rfe)) != ncol(df_rfe), ]
    rvals$data_warn_n <- sum(!complete.cases(df_check))
  }
  df_rfe <- df_rfe[complete.cases(df_rfe), ]
  df_scale <- df_rfe[, -c(1)]
  df_scale <- df_scale %>% mutate_if(is.numeric, scale)
  df_rfe <- cbind(df_rfe[, c(1)], df_scale)
  colnames(df_rfe)[1] <- input$dependentVar_r_fi
  df_rfe
})

# regression RFE data splits
y_r <- reactive({
  y_r <- rfe_r_data()
  y_r[, c(1)]
})

x_r <- reactive({
  x_r_rfe <- rfe_r_data()
  x_r <- x_r_rfe %>% select(-input$dependentVar_r_fi)
  x_r
})

dataTrain_r_rfe <- reactive({
  createDataPartition(y_r(), p = .80, list = FALSE)[, 1]
})

x_train_r_rfe <- reactive({
  x_r()[dataTrain_r_rfe(), ]
})

x_test_r_rfe <- reactive({
  x_r()[-dataTrain_r_rfe(), ]
})

y_train_r_rfe <- reactive({
  y_r()[dataTrain_r_rfe()]
})

y_test_r_rfe <- reactive({
  y_r()[-dataTrain_r_rfe()]
})

rfe_r_test <- reactive({
  postResample(predict(df_r_fi(), x_test_r_rfe()), y_test_r_rfe())
})

# download regression feature importance plot
output$download_r_fiplot <- downloadHandler(
  filename = function() {
    if (input$select_r_fimethod == "random forest") {
      paste("RandomForest_Regression_FeatureImportancePlot", ".png", sep = "")
    } else if (input$select_r_fimethod == "recursive feature elimination") {
      paste("RFE_Regression_FeatureImportancePlot", ".png", sep = "")
    }
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Plot"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        workingdir <- getwd()
        setwd(tempdir())
        if (input$select_r_fimethod == "random forest") {
          name <- paste("RandomForest_Regression_FeatureImportancePlot", ".png", sep = "")
        } else if (input$select_r_fimethod == "recursive feature elimination") {
          name <- paste("RFE_Regression_FeatureImportancePlot", ".png", sep = "")
        }
        shiny::incProgress(5 / 10)
        file.copy(name, file, overwrite = TRUE)
        setwd(workingdir)
      }
    )
  }
)

# download report for regression feature importance
output$report_r_fi <- downloadHandler(
  filename = "report_featureimportance.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_fi.Rmd")
        file.copy("report_fi.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_vars = input$feature_r_fi_variableSelect,
          dependent_var = input$dependentVar_r_fi,
          groups = rvals$groups_lvl,
          warning_data = rvals$data_warn,
          warning_data_n = rvals$data_warn_n,
          fi_method = input$fi_input,
          fi_model = input$select_r_fimethod,
          folds_n = input$c_n_folds,
          repeats_n = input$c_n_repeats,
          fi_output = rvals$rval_fi_output,
          fi_plot = rvals$rval_fi_plot,
          na_omit = rvals$na_omit,
          na_n = rvals$n_na
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

# plots

# create input data and choose plot
plot_data <- reactive({
  withProgress(message = "Plotting", value = 0, {
    incProgress(1 / 6)
    logscale <- input$logscale_switch
    var <- c(input$feature_p_variableSelect, input$groupVar_p)
    feature <- c(input$feature_p_variableSelect)
    group_col <- input$groupVar_p
    plot <- input$p_PlotSelect
    df_loaded <- rvals$rval_loadeddf
    df_processed <- rvals$rval_processeddf
    if (rvals$rval_chosendf == "processed") {
      if (!is.null(dim(df_processed))) {
        df_var <- df_processed
      }
    }
    if (rvals$rval_chosendf == "loaded") {
      if (!is.null(dim(df_loaded))) {
        df_var <- df_loaded
      }
    }
    if (!is.numeric(df_var[[feature]])) {
      showNotification(ui = "Please select a numeric input as feature", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(is.numeric(df_var[[feature]]), "Please select a numeric input as feature")
      )
    }
    if (is.numeric(df_var[[input$groupVar_p]])) {
      showNotification(ui = "Warning: group var is numeric", type = "warning", duration = 5, closeButton = TRUE)
    }
    if (length(unique(df_var[[input$groupVar_p]])) >= 20) {
      showNotification(ui = "Please select fewer groups", type = "error", duration = NULL, closeButton = TRUE)
      validate(
        need(length(unique(df_var[[input$groupVar_p]])) < 20, paste0(length(unique(df_var[[input$groupVar_p]])), " groups reported. Cannot process more than 20 unique groups."))
      )
    }
    obs_groups <- df_var %>%
      group_by_at(group_col) %>%
      count()
    if (any(obs_groups$n == 1)) {
      showNotification(ui = "Warning: only one observation in group", type = "warning", duration = 3, closeButton = TRUE)
    }
    g <- factor(df_var[[group_col]])
    if (NA %in% g) {
      rvals$na_omit <- TRUE
      df_na <- df_var[which(is.na(df_var[[group_col]])), ]
      df_na <- df_na[which(!is.na(df_na[[feature]])), ]
      rvals$n_na <- count(df_na)
      g <- na.omit(g)
      df_var <- df_var[!is.na(df_var[[group_col]]), ]
    } else {
      rvals$na_omit <- FALSE
      rvals$n_na <- 0
    }
    rvals$groups_lvl <- unique(df_var[[group_col]])
    if (logscale) {
      if (plot == "Violin plot") {
        df_var <- subset(df_var, df_var[[feature]] > 0)
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = group_col, y = feature, fill = group_col)) +
          geom_violin(adjust = 2, trim = FALSE) +
          theme_bw() +
          scale_y_log10() +
          ylab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_x_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(2 / 6)
      if (plot == "Boxplot") {
        df_var <- subset(df_var, df_var[[feature]] > 0)
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = group_col, y = feature, fill = group_col)) +
          geom_boxplot(width = 0.4, color = "black") +
          theme_bw() +
          scale_y_log10() +
          ylab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_x_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(3 / 6)
      if (plot == "Violin with Boxplot") {
        df_var <- subset(df_var, df_var[[feature]] > 0)
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = group_col, y = feature, fill = group_col)) +
          geom_violin(adjust = 2, trim = FALSE) +
          geom_boxplot(width = 0.1, color = "black") +
          theme_bw() +
          scale_y_log10() +
          ylab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_x_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(4 / 6)
      if (plot == "Ridgeline") {
        df_var <- subset(df_var, df_var[[feature]] > 0)
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = feature, y = group_col, fill = group_col)) +
          geom_density_ridges() +
          theme_ridges() +
          theme_bw() +
          scale_x_log10() +
          xlab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_y_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(5 / 6)
    } else {
      if (plot == "Violin plot") {
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = group_col, y = feature, fill = group_col)) +
          geom_violin(adjust = 2, trim = FALSE) +
          theme_bw() +
          ylab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_x_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(2 / 6)
      if (plot == "Boxplot") {
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = group_col, y = feature, fill = group_col)) +
          geom_boxplot(width = 0.4, color = "black") +
          theme_bw() +
          ylab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_x_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(3 / 6)
      if (plot == "Violin with Boxplot") {
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = group_col, y = feature, fill = group_col)) +
          geom_violin(adjust = 2, trim = FALSE) +
          geom_boxplot(width = 0.1, color = "black") +
          theme_bw() +
          ylab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_x_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(4 / 6)
      if (plot == "Ridgeline") {
        n_groups <- length(unique(df_var[[group_col]]))
        if (n_groups > 12) {
          group_colors <- sample(col_vector, n_groups)
        } else {
          group_colors <- my_palette
        }
        df_var[[group_col]] <- as.factor(df_var[[group_col]])
        n <- nrow(df_var[!is.na(df_var[[feature]]), ])
        x <- df_var %>%
          filter(!is.na(df_var[[feature]])) %>%
          group_by_at(group_col) %>%
          count()
        label <- paste0(x[[group_col]], "\n n = ", x$n)
        p <- ggplot(df_var, aes_string(x = feature, y = group_col, fill = group_col)) +
          geom_density_ridges() +
          theme_ridges() +
          theme_bw() +
          xlab(feature) +
          theme(legend.position = "none") +
          ggtitle("") +
          scale_fill_manual(values = group_colors) +
          scale_y_discrete(group_col, labels = c(label)) +
          theme(axis.text = element_text(size = 9, family = "sans")) +
          theme(axis.title = element_text(size = 11, family = "sans")) +
          theme(plot.title = element_text(size = 12, family = "sans")) +
          theme(panel.border = element_blank(), axis.line = element_line(color = "black", size = 0.5), axis.ticks = element_line(color = "black", size = 0.5), panel.grid.minor = element_blank(), panel.grid.major = element_blank()) +
          theme(plot.margin = unit(c(0.5, 0.5, 0.5, 0.5), "mm"))
      }
      incProgress(5 / 6)
    }
    rvals$rval_plot <- p
    p
  })
})

# render plot
output$Feature_Plot <- renderPlot({
  plot_df()
})

plot_df <- eventReactive(input$plotBtn, {
  if (is.null(dim(rvals$rval_loadeddf)) & is.null(dim(rvals$rval_processeddf))) {
    showNotification(ui = "Please load/process data first", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(dim(rvals$rval_loadeddf)), "No processed data found"),
      need(!is.null(dim(rvals$rval_processeddf)), "No loaded data found")
    )
  }
  if (is.null(input$feature_p_variableSelect)) {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!is.null(input$feature_p_variableSelect), "Please select a feature for analysis")
    )
  }
  if (input$feature_p_variableSelect == "... no features found") {
    showNotification(ui = "Please select a feature", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$feature_p_variableSelect != "... no features found", "Please select a feature for analysis")
    )
  }
  if (input$groupVar_p == "") {
    showNotification(ui = "Please specify a group variable", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_p != "", "Please specify a group variable")
    )
  }
  if (!(input$groupVar_p %in% names(rvals$rval_loadeddf) | input$groupVar_p %in% names(rvals$rval_processeddf))) {
    showNotification(ui = "Column name not found", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$groupVar_p %in% names(rvals$rval_loadeddf), "Column name not found in loaded dataframe"),
      need(input$groupVar_p %in% names(rvals$rval_processeddf), "Column name not found in processed dataframe")
    )
  }
  if (input$p_PlotSelect == "...") {
    showNotification(ui = "Please specify a plot type", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(input$p_PlotSelect != "...", "Please specify a plot type")
    )
  }
  if (input$groupVar_p %in% input$feature_p_variableSelect) {
    showNotification(ui = "Group and feature var overlap", type = "error", duration = NULL, closeButton = TRUE)
    validate(
      need(!(input$groupVar_p %in% input$feature_p_variableSelect), "Group variable and feature variable cannot be the same."),
    )
  } else {
    name <- paste(input$p_PlotSelect, "_", input$feature_p_variableSelect, ".png", sep = "")
    ggsave(name, plot_data(), path = tempdir())
    plot_data()
  }
})

# download plot
output$download_plot <- downloadHandler(
  filename = function() {
    paste(input$p_PlotSelect, "_", input$feature_p_variableSelect, ".png", sep = "")
  },
  content = function(file) {
    withProgress(
      message = paste0("Saving Plot"),
      value = 0,
      {
        shiny::incProgress(1 / 10)
        Sys.sleep(1)
        workingdir <- getwd()
        setwd(tempdir())
        name <- paste(input$p_PlotSelect, "_", input$feature_p_variableSelect, ".png", sep = "")
        shiny::incProgress(5 / 10)
        file.copy(name, file, overwrite = TRUE)
        setwd(workingdir)
      }
    )
  }
)

# download report for plot
output$report_plot <- downloadHandler(
  filename = "report_plot.html",
  content = function(file) {
    withProgress(
      message = paste0("Generating Report"),
      value = 0,
      {
        shiny::incProgress(1 / 5)
        src_img <- file.path(getwd(), "www/tRigon_logo.png")
        file.copy(src_img, "tRigon_logo.png")
        tempReport <- file.path(getwd(), "report_plot.Rmd")
        file.copy("report_plot.Rmd", tempReport, overwrite = FALSE)
        shiny::incProgress(2 / 5)
        # Set up parameters to pass to Rmd document
        params <- list(
          session_info = sessioninfo::session_info()$platform,
          feature_var = input$feature_p_variableSelect,
          group_var = input$groupVar_p,
          groups = rvals$groups_lvl,
          plot_selection = input$p_PlotSelect,
          scale = input$logscale_switch,
          plot = rvals$rval_plot,
          na_omit = rvals$na_omit,
          na_n = rvals$n_na
        )
        shiny::incProgress(3 / 5)
        rmarkdown::render(tempReport,
          output_file = file,
          params = params,
          envir = new.env(parent = globalenv())
        )
        shiny::incProgress(4 / 5)
      }
    )
  }
)

---
title: "Welcome to tRigon"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{tRigon}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```
Pathomics enables automated, reproducible and precise histopathology analysis and morphological phenotyping. Similar to other molecular omics, pathomics datasets are highly-dimensional and large in size, but also face increased outlier variability and inherent data missingness, making a quick and comprehensible data analysis challenging. 

To facilitate pathomics data analysis and interpretation as well as support a broad implementation for all researchers we developed tRigon (Toolbox foR InteGrative pathOmics aNalysis), a Shiny application built in the R environment for fast, comprehensive and reproducible pathomics analysis. tRigon allows researchers without coding abilities to perform their own exploratory feature analyses.

## Installation

Users  need to have the R environment and optionally RStudio installed. You can download them [here](https://posit.co/download/rstudio-desktop/). 

Next you can run the following code to install tRigon.

```{r eval = FALSE}
install.packages('tRigon')
```

## Usage

Once the tRigon package is installed. You can run the following code to start the web app.

```{r eval = FALSE}
library(tRigon)
tRigon::run_tRigon()
```

## Workflow and Functions

**Figure 1.** Overview of the available tRigon functions with their respective appearance in the user interface (ui).

<br></br>

<img src='tRigon_Figure1.png' alt='functions with ui' title='ui overview' width='700'/>

<br></br>

**Table 1.** tRigon functions with explanations.

| Section      | Function                                                     | Explanation                                                                                                   |
|--------------|--------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------| 
| **Data** |                                                              |                                                                                                               |
|              | Processing data                                             | tRigon can process .csv files of pathomics data together with provided experiment / clinical data meta files. tRigon aggregates pathomics files and assigns them to the provided labels from the metadata. Users can choose between processing human or animal experiment data with calculations on specimen or single-structure level. |                                                                            
|              | Loading data                                                 | tRigon can also be used to load other data (e.g., other omics datasets) or already processed pathomics files. |                                                                  
| **Statistics** |                                                            |                                                                                                               |                                                                                                                                                  
|              | Descriptive statistics                                       | Based on a provided group label tRigon can calculate summary statistics (e.g., mean, median, standard deviation, interquartile range) for each chosen feature. |                                                                                                                                                                                                                                                                                       
|              | Statistical tests                                             | tRigon supports a range of non-parametric statistical tests such as:<br />(1) pairwise Wilcoxon-rank tests with Bonferroni correction for multiple testing<br />(2) Kruskal-Wallis tests<br />(3) differences in median with bootstrapped confidence intervals for each desired feature and provided group label. |                                                                                                 
|              | Correlation                                                    | Simple and multiple correlations based on the Pearson-correlation coefficient can be calculated and visualized as a scatter plot or correlation matrix for each chosen feature. Users can also specify a group and subgroup for specific correlation analysis. |
|              | Machine learning                                              | For calculation of feature importance tRigon supports random forests and recursive feature elimination (RFE) for classification and regression of chosen features based on a selected dependent variable. For RFE users can also specify the number of folds for cross-validation as well as repeats. |
|   **Plots** |                                                             |                                                                                                          |                                                                                                                                         
|                | Distribution plots                                          | Based on a provided group label tRigon plots selected feature distributions in a variety of plots:<br />(1) violin plots<br />(2) box plots<br />(3) ridgeline plots |      
|                | Clustering                                                  | tRigon supports k-means clustering for selected variables. Groups can also be plotted within a separate legend. | 
| **Data** |                                                              |                                                                                                               |
|                 | Markdown reports                                                  | For each function tRigon users can download a markdown report in .html format including all relevant inputs and outputs of the application. |                                                                      
## Data Preparation

tRigon supports .xlsx and .csv formats as data inputs for processing pathomics files or loading own datasets.

**Note that**: For processing pathomics files users need the raw data including a meta data file in .xlsx format containing additional information. For human and/or animal experiment data there are different conditions on how the meta data has to be organized. These can be found in the **Help** section of the application.

## Demo Data

FLASH-generated pathomics demo files for five human and mouse datasets as well as three non-pathomics medical datasets have been provided. Please use this [link to access](https://git-ce.rwth-aachen.de/labooratory-ai/trigon/-/blob/main/demo_data.zip) the demo data.

## Citation

If you find this shiny application useful, please consider citing the corresponding publication:

- tRigon: an R package and Shiny App for integrative pathomics analysis [David L. Hölscher, Michael Goedertier, Barbara M. Klinkhammer, Patrick Droste, Ivan G. Costa, Peter Boor, Roman D. Bülow]

## Further Information

Further information on how to use tRigon for analysis and data processing are provided in the **Help** section of the application.

Information regarding **FLASH (framework for large-scale histomorphometry)** can be found [here](https://www.nature.com/articles/s41467-023-36173-0)

# Contact us To get in contact with our group, please visit: [LaBOORatory website](https://www.ukaachen.de/kliniken-institute/institut-fuer-pathologie/forschung/labooratory-of-nephropathology/our-interest) To follow our AI and biostatistics-based projects, please visit: [LaBOORatory GitLab](https://git-ce.rwth-aachen.de/labooratory-ai) ------ # Report bugs To report bugs and/or request features, please use the following GitLab issue channel: [https://git-ce.rwth-aachen.de/labooratory-ai/tRigon/-/issues](https://git-ce.rwth-aachen.de/labooratory-ai/trigon/-/issues) ------ # Citation If you find **tRigon** useful, please consider citing our publication: [David L. Hölscher, Michael Goedertier, Barbara M. Klinkhammer, Patrick Droste, Ivan G. Costa, Peter Boor, Roman D. Bülow. tRigon: an R package and Shiny App for integrative (path-)omics data analysis, BMC Bioinformatics (2024).](https://bmcbioinformatics.biomedcentral.com/articles/10.1186/s12859-024-05721-w) ------

---
title: "Session Report - k-means Clustering"
output: html_document
params:
  session_info: NA ,
  feature_vars: NA,
  clusters_n: NA,
  groups_en: NA,
  group_var: NA,
  groups: NA,
  cluster_output: NA,
  cluster_plot: NA,
  warning_data: NA,
  warning_data_n: NA
---
```{r, echo=FALSE}
htmltools::img(
  src = "tRigon_logo.png",
  alt = "logo",
  style = "position:absolute; top:0px; right:135px; height: 80px"
)
```
---

```{r, echo = FALSE}
params$session_info
```

features:
```{r, echo = FALSE}
params$feature_vars
```

compare groups enabled?
```{r, echo = FALSE}
if (params$groups_en == FALSE) {
  print("Compare groups disabled.")
} else if (params$groups_en == TRUE) {
  print("Compare groups enabled.")
}
```

```{r, echo = FALSE}
if (params$groups_en == TRUE) {
  print(paste0("grouping variable: ", params$group_var))
}
``` 

```{r, echo = FALSE}
if (params$groups_en == TRUE) {
  params$groups
}
```      

data missingness:
```{r, echo = FALSE}
if (params$warning_data) {
  print(paste0(
    "Warning: input vectors of unequal length - only complete rows can be analysed for k-means clustering. ", params$warning_data_n, " rows with missing data excluded."
  ))
} else {
  print("no missing data reported.")
}
```

cluster output:
```{r, echo = FALSE}
params$cluster_output
```

cluster plot:
<br/>
```{r dev='png', echo = FALSE}
plot(params$cluster_plot)
```

---
title: "Session Report - Data Processing"
output: html_document
params:
  session_info: NA,
  human_processing_en: NA,
  calculations_en: NA,
  datapath_metadata: NA,
  datapath_processdata: NA,
  processed_datadf: NA,
  meta_datadf: NA,
  matchedID_datadf: NA,
  n_files: NA
---
```{r, echo=FALSE}
htmltools::img(
  src = "tRigon_logo.png",
  alt = "logo",
  style = "position:absolute; top:0px; right:135px; height: 80px"
)
```
---

```{r, echo = FALSE}
params$session_info
```

data input:
```{r, echo = FALSE}
if (params$human_processing_en) {
  print("Human data was processed.")
} else {
  print("Mouse data was processed.")
}
```

n feature files processed:
```{r, echo = FALSE}
params$n_files
```

feature files processed:
```{r, echo = FALSE}
params$datapath_processdata$name
```

metadata file processed:
```{r, echo = FALSE}
params$datapath_metadata$name
```

columns in metadata file:
```{r, echo = FALSE}
colnames(params$meta_datadf)
```

columns in processed file:
```{r, echo = FALSE}
colnames(params$processed_datadf)
```

feature calculations:
```{r, echo = FALSE}
if (params$calculations_en) {
  print("calculations enabled: keeping calculated columns with mean / median / sd.")
} else {
  print("calculations disabled: deleting calculated columns from processed data.")
}
```

n columns in processed file:
```{r, echo = FALSE}
ncol(params$processed_datadf)
```

n rows in processed file:
```{r, echo = FALSE}
nrow(params$processed_datadf)
```

matched IDs in feature & clinical files:
```{r, echo = FALSE}
if (FALSE %in% params$matchedID_datadf$match) {
  print("Warning: some IDs did not match!")
} else {
  print("All IDs matched!")
}
params$matchedID_datadf
```

# Welcome to tRigon &nbsp;<img src='tRigon_logo.png' align="right" height="200"/>

<b><span style="color:#F17F42">tRigon</span></b> stands for <b><span style="color:#F17F42">toolbox for integrative pathomics analysis</span></b> and provides users with flexible and efficient ways to evaluate and explore (path-) omics datasets. tRigon is built to be compatible with the framework for large-scale histomorphometry (FLASH) environment, but not limited to it.

tRigon offers several key features: 
  
(1) processing, aggregating and merging of pathomics files with clinical / experiment metadata for aggregation of highly-dimensional data frames.

(2) evaluating the generated pathomics data using descriptive statistics, multiple types of plots, statistical tests, k-means clustering, feature importance algorithms and correlation analysis.

(3) options for downloading plots, generated data, statistical outputs, as well as experiment reports for each analysis step for reproducibility.

---
  
# Workflow
  
  The use of tRigon is simple and intuitive. Information are available in the README file and you can also follow the extensive user guide in the help tab to perform your analysis. 

Demo files for tRigon can be [downloaded here](https://git-ce.rwth-aachen.de/labooratory-ai/trigon/-/blob/main/demo_data.zip) in the provided data repository.

Code for our framework for large-scale automated histomorphometry (FLASH) to generate pathomics files can also be [accessed here](https://git-ce.rwth-aachen.de/labooratory-ai/flash)

---
  
# About tRigon
  
tRigon is publicly available in the [CRAN repository](https://cran.r-project.org/web/packages/tRigon/index.html), with source code available on [GitLab](https://git-ce.rwth-aachen.de/labooratory-ai/trigon) under a GPL-3 license. 

The web application can be installed in R / RStudio using a simple command `install.packages("tRigon")`, and run locally with the command `tRigon::run_tRigon()`. Alternatively, the web application can be freely accessed for direct online use at [https://labooratory.shinyapps.io/tRigon/](https://labooratory.shinyapps.io/tRigon/). 

---

---
title: "Session Report - Feature Importance"
output: html_document
params:
  session_info: NA ,
  feature_vars: NA,
  dependent_var: NA,
  groups: NA,
  fi_model: NA,
  fi_method: NA,
  folds_n: NA,
  repeats_n: NA,
  fi_output: NA,
  fi_plot: NA,
  warning_data: NA,
  warning_data_n: NA,
  na_omit : NA,
  na_n: NA
---
```{r setup, include=FALSE} 
knitr::opts_chunk$set(warning = FALSE, message = FALSE)
```

```{r, echo=FALSE}
htmltools::img(
  src = "tRigon_logo.png",
  alt = "logo",
  style = "position:absolute; top:0px; right:135px; height: 80px"
)
```
---

```{r, echo = FALSE}
params$session_info
```

features:
```{r, echo = FALSE}
params$feature_vars
```

dependent variable:
```{r, echo = FALSE}
params$dependent_var
```

groups / levels of dependent variable:
```{r, echo = FALSE}
if (params$fi_method == "Classification") {
  print(params$groups)
  if (params$na_omit == TRUE) {
    print(paste0("Warning: dependent variable contains NAs. ", params$na_n, " values excluded."))
  }
} else if (params$fi_method == "Regression") {
  print(paste0("numeric variable for regression: ", params$dependent_var))
  if (params$na_omit == TRUE) {
    print(paste0("Warning: dependent variable contains NAs. ", params$na_n, " values excluded."))
  }
}
``` 

feature importance method:
```{r, echo = FALSE}
if (params$fi_method == "Classification") { # classification
  if (params$fi_model == "recursive feature elimination") {
    print(paste0("recursive feature elimination (RFE) with ", params$folds_n, "-fold cross-validation and ", params$repeats_n, " repeats for classification of groups of the dependent variable. Data is distributed in a random 80/20 split for training and testing."))
  } else if (params$fi_model == "random forest") {
    print("random forest model for classification of the dependent variable.")
  }
} else if (params$fi_method == "Regression") { # Regression
  if (params$fi_model == "recursive feature elimination") {
    print(paste0("recursive feature elimination (RFE) with ", params$folds_n, "-fold cross-validation and ", params$repeats_n, " repeats for regression of the dependent variable. Data is distributed in a random 80/20 split for training and testing."))
  } else if (params$fi_model == "random forest") {
    print("random forest model for regression of the dependent variable.")
  }
}
```      

feature imbalance:
```{r, echo = FALSE}
if (params$warning_data) {
  print(paste0("Warning: input vectors of unequal length - only complete rows can be analysed for feature importance. ", params$warning_data_n, " rows with missing data excluded."))
} else {
  print("no imbalance in feature vector data reported.")
}
```

feature importance output:
```{r, echo = FALSE}
params$fi_output
```

feature importance plot:
<br/>
```{r dev='png', echo = FALSE}
plot(params$fi_plot)
```

---
title: "Session Report - Descriptive Statistics"
output: html_document
params:
  session_info: NA ,
  feature_var: NA,
  group_var: NA,
  groups: NA,
  ds_df: NA,
  na_omit : NA,
  na_n: NA
---
```{r setup, include=FALSE} 
knitr::opts_chunk$set(warning = FALSE, message = FALSE)
```

```{r, echo=FALSE}
htmltools::img(
  src = "tRigon_logo.png",
  alt = "logo",
  style = "position:absolute; top:0px; right:135px; height: 80px"
)
```
---

```{r, echo = FALSE}
params$session_info
```

feature:
```{r, echo = FALSE}
params$feature_var
```

group variable:
```{r, echo = FALSE}
params$group_var
```

groups:
```{r, echo = FALSE}
params$groups
if (params$na_omit == TRUE) {
  print(paste0("Warning: group variable contains NAs. ", params$na_n, " values excluded."))
}
```

descriptive statistics:
```{r, echo = FALSE}
knitr::kable(params$ds_df, format = "markdown")
```

---
title: "Session Report - Correlation"
output: html_document
params:
  session_info: NA,
  corr_method: NA,
  feature_vars: NA,
  subgroups_en: NA,
  group_corr: NA,
  subgroup_corr: NA,
  corr_df: NA,
  corr_plot: NA,
  warning_data: NA,
  warning_data_n: NA
---
```{r, echo=FALSE}
htmltools::img(
  src = "tRigon_logo.png",
  alt = "logo",
  style = "position:absolute; top:0px; right:135px; height: 80px"
)
```
---

```{r, echo = FALSE}
params$session_info
```

```{r, echo = FALSE}
if (params$corr_method == "Simple") {
  print("Simple correlation between two variables.")
} else if (params$corr_method == "Multiple") {
  print(paste0(
    "Multiple correlation with ", length(params$feature_vars),
    " features."
  ))
}
```

features:
```{r, echo = FALSE}
params$feature_vars
```

subgroups?
```{r, echo = FALSE}
if (params$subgroups_en) {
  print(paste0("Subgroup analysis is enabled. Chosen grouping variable is ", params$group_corr, " with only analysis of features from ", params$subgroup_corr))
} else if (params$subgroups_en == FALSE) {
  print("Subgroup analysis is disabled.")
}
```

data missingness:
```{r, echo = FALSE}
if (params$warning_data) {
  print(paste0("Warning: input vectors of unequal length - only complete rows / complete data pairs can be analysed for correlation. ", params$warning_data_n, " rows with missing data excluded."))
} else {
  print("no missing data reported.")
}
```

correlation data:
```{r, echo = FALSE}
if (params$corr_method == "Multiple") {
  knitr::kable(params$corr_df, format = "markdown")
} else if (params$corr_method == "Simple") {
  print(paste0("simple correlation Pearson's R: ", params$corr_df[1, 3], " p-value: ", params$corr_df[1, 4]))
}
```

correlation plot:
<br/>
```{r dev='png', echo = FALSE}
plot(params$corr_plot)
```

---
title: "Session Report - Loading Data"
output: html_document
params:
  session_info: NA,
  datapath_loadeddf: NA,
  loaded_df: NA
---
```{r, echo=FALSE}
htmltools::img(src = "tRigon_logo.png",
               alt = 'logo', 
               style = 'position:absolute; top:0px; right:135px; height: 80px')
```
---

```{r, echo = FALSE}
params$session_info
```

file loaded:
```{r, echo = FALSE}
params$datapath_loadeddf$name
```

columns in loaded file:
```{r, echo = FALSE}
colnames(params$loaded_df)
```

n columns in loaded file:
```{r, echo = FALSE}
ncol(params$loaded_df)
```

n rows in loaded file:
```{r, echo = FALSE}
nrow(params$loaded_df)
```
